      subroutine top23treesqamp(p,matrixsq)

c  sumed over spin and colors and averaged over initial spin ,color

      implicit none
      double precision p(0:3,6), colorfactor
      double complex f1(6), f2(6), f3(6), f4(6), f5(6), i1(6), i2(6)
      double complex vertex, ampsub(4), i3(6)
      double precision matrixsq, averagefactor, zero, aux
      integer i,j,nh1,nh2,nh3,nh4,nh5
      parameter (zero=0.d0)
      double precision, dimension(2) :: zero2=(/0.d0, 0.d0/)
      include "para.inc" 
c color factor

      averagefactor=1.d0/2.d0/nc
      colorfactor=nc*cf

      matrixsq=0.d0

c helicity amplitudes calculation
      do nh1=-1+por*(1+por), 1-por*(por-1),2
      do nh2=1,1
      do nh3=-1,-1
      do nh4=-1,-1
      do nh5=-1,1,2

      call ixxxxx(p(0,1), mt, nh1, 1, f1)
      call ixxxxx(p(0,2), zero, nh2, -1, f2)
      call oxxxxx(p(0,3), zero, nh3, 1, f3)
      call oxxxxx(p(0,4), zero, nh4, 1, f4)
      call vxxxxx(p(0,5), zero, nh5, 1, f5)

      call jioqqx(f2, f3, 1.d0, 0.d0, zero2, 0, i3)
c diagram 1

      call fvoqqx(f4, f5, 1.d0, 1.d0, zero, 1, i1)
      call fviqqx(f1, f5, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(f1, i1, i3, 1.d0, 0.d0, ampsub(1))
      call iovqqx(i2, f4, i3, 1.d0, 0.d0, ampsub(2))
      
      vertex=ampsub(1)+ampsub(2)

      matrixsq=matrixsq+dble(vertex*conjg(vertex))

      enddo
      enddo
      enddo
      enddo
      enddo
cc end of helicity calculations


      matrixsq=(4.d0*pi*alphas)*(2.d0*dsqrt(2.d0)*GF*mw**2)*
     -        averagefactor*colorfactor*matrixsq


      end subroutine


      subroutine top23diposqamp(p,matrixsq)

c  sumed over spin and colors and averaged over initial spin ,color

      implicit none
      double precision p(0:3,6), colorfactor
      double complex f1(6), f2(6), f3(6), f4(6), f5(6), i1(6), i2(6)
      double complex vertex1, vertex2, ampsub(4), i3(6), f6(6)
      double precision averagefactor, zero
      double complex matrixsq(4)
      integer i,j,nh1,nh2,nh3,nh4,nh5
      parameter (zero=0.d0)
      double precision, dimension(2) :: zero2=(/0.d0, 0.d0/)
      include "para.inc" 
c color factor

      averagefactor=1.d0/2.d0/nc
      colorfactor=nc*cf

      do i=1, 4
      matrixsq(i)=dcmplx(0.d0, 0.d0)
      enddo

cc helicity amplitudes calculation
      do nh1=-1+por*(1+por), 1-por*(por-1),2
      do nh2=1,1
      do nh3=-1,-1
      do nh4=-1,-1

      call ixxxxx(p(0,1), mt, nh1, 1, f1)
      call ixxxxx(p(0,2), zero, nh2, -1, f2)
      call oxxxxx(p(0,3), zero, nh3, 1, f3)
      call oxxxxx(p(0,4), zero, nh4, 1, f4)
      call vxxxxx(p(0,5), zero,  1, 1, f5)
      call vxxxxx(p(0,5), zero, -1, 1, f6)

      call jioqqx(f2, f3, 1.d0, 0.d0, zero2, 0, i3)
c diagram 1

      call fvoqqx(f4, f5, 1.d0, 1.d0, zero, 1, i1)
      call fviqqx(f1, f5, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(f1, i1, i3, 1.d0, 0.d0, ampsub(1))
      call iovqqx(i2, f4, i3, 1.d0, 0.d0, ampsub(2))
      
      vertex1=ampsub(1)+ampsub(2)

      call fvoqqx(f4, f6, 1.d0, 1.d0, zero, 1, i1)
      call fviqqx(f1, f6, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(f1, i1, i3, 1.d0, 0.d0, ampsub(1))
      call iovqqx(i2, f4, i3, 1.d0, 0.d0, ampsub(2))
      
      vertex2=ampsub(1)+ampsub(2)

      matrixsq(1)=matrixsq(1)+vertex1*conjg(vertex1)
      matrixsq(2)=matrixsq(2)+vertex2*conjg(vertex2)
      matrixsq(3)=matrixsq(3)+vertex1*conjg(vertex2)
      matrixsq(4)=matrixsq(4)+vertex2*conjg(vertex1)

      enddo
      enddo
      enddo
      enddo
cc end of helicity calculations

      do i=1, 4
      matrixsq(i)=(4.d0*pi*alphas)*(2.d0*dsqrt(2.d0)*GF*mw**2)*
     -        averagefactor*colorfactor*matrixsq(i)
      enddo

      end subroutine


      subroutine top23intdsqamp(p, matrixsq)
      implicit none
      double precision matrixsq, p(0:3, 6)
      double precision aux(4)
      include "para.inc"

      aux(1)=0.d0
      aux(2)=0.d0
      aux(3)=0.d0
      aux(4)=0.d0

      call top23treesqamp(p, matrixsq)
      call top23intgg(p, aux(1))    

      call top23intqq(p, aux(2))    

      call top23intbb(p, aux(3)) 

! terms that convert the dipoles into DRED(FDH) scheme
! ref. Catani, et.al., hep-ph/9605323,0011222
      aux(4)=-(alphas/2.d0/pi)*(cf/2.d0+ca/6.d0)   

      matrixsq=(aux(1)+aux(2)+aux(3)+aux(4))*matrixsq

      end subroutine

      subroutine top23intgg(p, matrixsq)
      implicit none
      double precision matrixsq, p(0:3, 6), intdip, cfac
      external intdip
      include "para.inc"

      matrixsq=0.d0
 
      cfac=-ca/2.d0/cf
      matrixsq=matrixsq+cfac*intdip(p, 1)

      cfac=-ca/2.d0/cf
      matrixsq=matrixsq+cfac*intdip(p, 2)

      cfac=(ca-2.d0*cf)/2.d0/cf
      matrixsq=matrixsq+cfac*intdip(p, 3)

      cfac=(ca-2.d0*cf)/2.d0/cf
      matrixsq=matrixsq+cfac*intdip(p, 4)

      cfac=-ca/2.d0/ca
      matrixsq=matrixsq+cfac*intdip(p, 5)

      cfac=-ca/2.d0/ca
      matrixsq=matrixsq+cfac*intdip(p, 6)

      cfac=-ca/2.d0/ca
      matrixsq=matrixsq+cfac*intdip(p, 7)

      matrixsq=matrixsq*(-alphas/2.d0/pi)

      matrixsq=matrixsq/2.d0  !average factor from bb

      end subroutine

      subroutine top23intqq(p, matrixsq)
      implicit none
      double precision matrixsq, p(0:3, 6), intdip, cfac
      external intdip
      include "para.inc"

      matrixsq=0.d0
 
      cfac=-1.d0
      matrixsq=matrixsq+cfac*intdip(p, 8)

      matrixsq=matrixsq*(-alphas/2.d0/pi)*(nf-1.d0)

      end subroutine

      subroutine top23intbb(p, matrixsq)
      implicit none
      double precision matrixsq, p(0:3, 6), intdip, cfac
      external intdip
      include "para.inc"

      matrixsq=0.d0
 
      cfac=-1.d0
      matrixsq=matrixsq+cfac*intdip(p, 9)

      cfac=-1.d0
      matrixsq=matrixsq+cfac*intdip(p, 10)

      matrixsq=matrixsq*(-alphas/2.d0/pi)

      matrixsq=matrixsq/2.d0  !average factor from bb

      end subroutine


      double precision function intdip(p, n)
      implicit none
      double precision p(0:3, 6), r, r1, gm, psum(0:3), lg6
      double precision gdot, sijk, lg1, ddilog, lg2, lg3, lg4
      double precision a1, a2, a3, a4, a5, a6, a7, a8, a9, llg
      double precision r12, r13, r14, r15
      integer n, i
      external gm, gdot, ddilog
      include "para.inc"

      intdip=0.d0
      r=0.5d0
      sijk=gdot(p(0, 1), p(0, 1))/(2.d0*gdot(p(0, 4), p(0, 5)))
      lg1=dlog(sijk)
      lg2=dlog(dipcut)
      if((n.eq.3).or.(n.eq.4)) then
      do i=0, 3
      psum(i)=p(i, 2)+p(i, 3)+p(i, 5)
      enddo
      r=gm(psum(0))/gm(p(0, 1))
      elseif((n.eq.6).or.(n.eq.7)) then
      do i=0, 3
      psum(i)=p(i, 2)+p(i, 3)+p(i, 4)
      enddo
      r=gm(psum(0))/gm(p(0, 1))
      endif
      r1=1.d0-r**2
      r12=r1**2
      r13=r1**3
      r14=r1**4
      r15=r1**5

      lg3=dlog(r)
      lg4=dlog(r1)
      lg6=dlog(dipcut)
      llg=ddilog(r1)
      

      if((n.eq.1).or.(n.eq.2)) then      

      intdip=cf*((div**2-lg2**2+div*lg1+lg1**2/2.d0)+3.d0/2.d0*(div
     -    -1.d0+dipcut-lg2+lg1)+5.d0-pi**2/2.d0)

      elseif(n.eq.5) then

      intdip=2.d0*ca*((div**2-lg2**2+div*lg1+lg1**2/2.d0)+11.d0/6.d0
     -   *(div-1.d0+dipcut-lg2+lg1)+50.d0/9.d0-pi**2/2.d0)

      elseif(n.eq.8) then

      intdip=tr*(-2.d0/3.d0*(div-1.d0+dipcut-lg2+lg1)-16.d0/9.d0)

      elseif((n.eq.9).or.(n.eq.10)) then

      intdip=tr*(-2.d0/3.d0*(div-1.d0+dipcut-lg2+lg1)-16.d0/9.d0)

      elseif((n.eq.3).or.(n.eq.4)) then
     
      if(r1.gt.1.d-2) then

      intdip=-1.d0*(-cf)*(div**2+div*(5.d0/2.d0-2.d0*lg4)+27.d0/4.d0+
     -   (1.d0/r1**2-8.d0/r1+7.d0)*lg3+1.d0/2.d0/r1+2.d0*llg
     -   -5.d0*pi**2/6.d0-5.d0*lg4+2.d0*lg4**2-2.d0*lg2**2-
     -    (7.d0/2.d0-4.d0*dipcut+dipcut**2/2.d0)*lg2+2.d0*(1.d0-dipcut)
     -   *r**2/r1*dlog((1.d0-r1)/(1.d0-dipcut*r1)))

      else  !in order to solve the unstable numerical when r1->0
            !using the approximate formula

      intdip=-1.d0*(-cf)*(div**2+div*(5.d0/2.d0-2.d0*lg4)+27.d0/4.d0+
     -   15.d0/4.d0-5.d0*r1/3.d0-13.d0*r12/24.d0-4.d0*r13/15.d0
     -   -19.d0*r14/120.d0+2.d0*llg
     -   -5.d0*pi**2/6.d0-5.d0*lg4+2.d0*lg4**2-2.d0*lg2**2-
     -    (7.d0/2.d0-4.d0*dipcut+dipcut**2/2.d0)*lg2+2.d0*(1.d0-dipcut)
     -   *r**2/r1*dlog((1.d0-r1)/(1.d0-dipcut*r1)))

      endif

      elseif((n.eq.6).or.(n.eq.7)) then

      a1=dipcut
      a2=dipcut**2
      a3=dipcut**3
      a4=dipcut**4
      a5=dipcut**5
      a6=dipcut**6
      a7=dipcut**7
      a8=dipcut**8
      a9=dipcut**9

      intdip=0.d0

      if(r1.gt.1.d-2) then

      intdip=intdip+(div**2/2.d0+
     - (17.d0-12.d0*lg4)*div/12.d0-5.d0*pi**2/12.d0-lg2**2-
     - (1.d0-dipcut)*(23.d0-dipcut+2.d0*a2)/12.d0*lg2+lg4**2
     - -17.d0/6.d0*lg4-r**2*lg3/6.d0/r15*(6.d0*a3*(1-r1)*(-2+r1)
     - -3*a2*(1-r1)*(-6+5*r1)+12*dipcut*r1*(r**2+r13)+r12*(2+
     -  r1*(-1+11*r1))))

      intdip=intdip+((1-dipcut)*r**2*dlog(1-dipcut*r1)/4.d0/r15
     -  *(-2*a2*(1-r1)*(-2+r1)+dipcut*(-2+(5-3*r1)*r1)-2+r1+r12
     -  -4*r14)+llg)

      intdip=intdip-(1.d0/240.d0/r14/(1-dipcut*r1)*(-8*a9*r15
     -  -6*a8*r14*(2-7*r1)-a7*r13*(20-68*r1+115*r12)+a6*r12*(
     -  -40+130*r1-165*r12+216*r13)-a5*r1*(120-360*r1+410*r12
     -  -234*r13+305*r14)+a4*(240-180*r1-510*r12+650*r13-195*r14
     -  +278*r15)-a3*(600-1140*r1+280*r12+460*r13-92*r14+97*r15)
     -  +a2*(360-1140*r1+900*r12+50*r13-63*r14-40*r15)
     -  +10*dipcut*(12+6*r1-36*r12+10*r13+8*r14+91*r15)
     -  +10*r12*(4*r**2-91*r12))) 

      else  !in order to solve the unstable numerical when r1->0
            !using the approximate formula

      intdip=intdip+(170 - 6*a4 + 18*div**2 + div*(51 - 36*lg4) - 
     -     102*lg4 + 36*lg4**2 - 69*lg6 - 36*lg6**2 - 
     -     9*a2*(5 + lg6) + 3*a3*(5 + 2*lg6) + 
     -     a1*(69 + 72*lg6) + 36*llg - 15*Pi**2)/36. + 
     -  ((-55 - 176*a1 + 178*a2 - 40*a3 - 70*a4 + 92*a5 - 
     -       54*a6 + 12*a7)*r1)/120. + 
     -  ((-259 - 252*a1 - 851*a2 + 1398*a3 - 315*a4 - 
     -       840*a5 - 40*a5**2 + 987*a6 - 314*a7 - 238*a8 + 
     -       200*a9)*r12)/1680. + 
     -  ((-392 - 372*a1 - 15*a2 - 1686*a3 + 2940*a4 - 
     -       588*a5 + 1035*a5**2 - 2268*a6 - 210*a5*a6 + 
     -       2400*a7 - 69*a8 - 1560*a9)*r13)/5040. + 
     -  ((-474 - 444*a1 - 15*a2 - 10*a3 - 2520*a4 + 4536*a5 - 
     -       4365*a5**2 - 756*a6 + 2730*a5*a6 - 560*a6**2 - 
     -       4200*a7 + 4035*a8 + 1100*a9)*r14)/10080.

      endif

      intdip=(-1.d0*(-4.d0*ca)*(1.d0/2.d0))*intdip

      else

      print *, "wrong intdipole!"
      stop

      endif

      end function
