      subroutine top24coutsqamp(p, matrixsq, weight)
      implicit none
      double precision p(0:3, 6), matrixsq, aux, weight
      include "para.inc"

      matrixsq=0.d0

      call top24coutgg(p, aux, weight)
      matrixsq=matrixsq+aux

      call top24coutqq(p, aux, weight)
      matrixsq=matrixsq+aux

      call top24coutbb(p, aux, weight)
      matrixsq=matrixsq+aux

      end subroutine
      
 
      subroutine top24coutgg(p, matrixsq, weight)
      implicit none
      double precision p(0:3, 6), matrixsq, pout(0:3, 6)
      double precision matrixsq1, weight, pjet(0:3, 6), auxx
      double complex sp(2, 2), aux(4), czero
      parameter (czero=dcmplx(0.d0, 0.d0))
      common /pass/ pjet
      include "para.inc"

      matrixsq=0.d0
      matrixsq1=0.d0

      call topdipole(5, 4, 6, 0, 1, p, pout, sp)

      if((sp(1, 1)+sp(1, 2)+sp(2, 1)+sp(2, 2)).ne.czero) then
      call top23diposqamp(pout, aux)

      matrixsq1=-dble(sp(1, 1)*aux(1)+sp(2, 2)*aux(2)
     -     +sp(1, 2)*aux(3)+sp(2, 1)*aux(4))/2.d0

      matrixsq=matrixsq+matrixsq1
      auxx=matrixsq1*weight
      if(auxx.ne.auxx) then
         print *, "nan here"
         auxx=0.d0
      endif
      call recordevent(3, pjet, auxx)
      endif


      call topdipole(6, 4, 5, 0, 1, p, pout, sp)

      if((sp(1, 1)+sp(1, 2)+sp(2, 1)+sp(2, 2)).ne.czero) then
      call top23diposqamp(pout, aux)

      matrixsq1=-dble(sp(1, 1)*aux(1)+sp(2, 2)*aux(2)
     -     +sp(1, 2)*aux(3)+sp(2, 1)*aux(4))/2.d0

      matrixsq=matrixsq+matrixsq1
      auxx=matrixsq1*weight
      if(auxx.ne.auxx) then
         print *, "nan here"
         auxx=0.d0
      endif
      call recordevent(3, pjet, auxx)
      endif

      call topdipole(5, 4, 1, 0, 1, p, pout, sp)

      if((sp(1, 1)+sp(1, 2)+sp(2, 1)+sp(2, 2)).ne.czero) then
      call top23diposqamp(pout, aux)

      matrixsq1=-dble(sp(1, 1)*aux(1)+sp(2, 2)*aux(2)
     -     +sp(1, 2)*aux(3)+sp(2, 1)*aux(4))/2.d0

      matrixsq=matrixsq+matrixsq1
      auxx=matrixsq1*weight
      if(auxx.ne.auxx) then
         print *, "nan here"
         auxx=0.d0
      endif
      call recordevent(3, pjet, auxx)
      endif

      call topdipole(6, 4, 1, 0, 1, p, pout, sp)

      if((sp(1, 1)+sp(1, 2)+sp(2, 1)+sp(2, 2)).ne.czero) then
      call top23diposqamp(pout, aux)

      matrixsq1=-dble(sp(1, 1)*aux(1)+sp(2, 2)*aux(2)
     -     +sp(1, 2)*aux(3)+sp(2, 1)*aux(4))/2.d0

      matrixsq=matrixsq+matrixsq1
      auxx=matrixsq1*weight
      if(auxx.ne.auxx) then
         print *, "nan here"
         auxx=0.d0
      endif
      call recordevent(3, pjet, auxx)
      endif

      call topdipole(5, 6, 4, 0, 0, p, pout, sp)

      if((sp(1, 1)+sp(1, 2)+sp(2, 1)+sp(2, 2)).ne.czero) then
      call top23diposqamp(pout, aux)

      matrixsq1=-dble(sp(1, 1)*aux(1)+sp(2, 2)*aux(2)
     -     +sp(1, 2)*aux(3)+sp(2, 1)*aux(4))/2.d0

      matrixsq=matrixsq+matrixsq1
      auxx=matrixsq1*weight
      if(auxx.ne.auxx) then
         print *, "nan here"
         auxx=0.d0
      endif
      call recordevent(3, pjet, auxx)
      endif

      call topdipole(5, 6, 1, 0, 0, p, pout, sp)

      if((sp(1, 1)+sp(1, 2)+sp(2, 1)+sp(2, 2)).ne.czero) then
      call top23diposqamp(pout, aux)

      matrixsq1=-dble(sp(1, 1)*aux(1)+sp(2, 2)*aux(2)
     -     +sp(1, 2)*aux(3)+sp(2, 1)*aux(4))/2.d0

      matrixsq=matrixsq+matrixsq1
      auxx=matrixsq1*weight
      if(auxx.ne.auxx) then
         print *, "nan here"
         auxx=0.d0
      endif
      call recordevent(3, pjet, auxx)
      endif

      call topdipole(6, 5, 1, 0, 0, p, pout, sp)

      if((sp(1, 1)+sp(1, 2)+sp(2, 1)+sp(2, 2)).ne.czero) then
      call top23diposqamp(pout, aux)

      matrixsq1=-dble(sp(1, 1)*aux(1)+sp(2, 2)*aux(2)
     -     +sp(1, 2)*aux(3)+sp(2, 1)*aux(4))/2.d0

      matrixsq=matrixsq+matrixsq1
      auxx=matrixsq1*weight
      if(auxx.ne.auxx) then
         print *, "nan here"
         auxx=0.d0
      endif
      call recordevent(3, pjet, auxx)
      endif

      end subroutine

       
      subroutine top24coutqq(p, matrixsq, weight)
      implicit none
      double precision p(0:3, 6), matrixsq, pout(0:3, 6)
      double precision matrixsq1, weight, pjet(0:3, 6), auxx
      double complex sp(2, 2), aux(4)
      common /pass/ pjet
      include "para.inc"

      matrixsq=0.d0
      matrixsq1=0.d0

      call topdipole(5, 6, 4, 1, -1, p, pout, sp)

      call top23diposqamp(pout, aux)

      matrixsq1=-dble(sp(1, 1)*aux(1)+sp(2, 2)*aux(2)
     -     +sp(1, 2)*aux(3)+sp(2, 1)*aux(4))*(nf-1.d0)

      matrixsq=matrixsq+matrixsq1
      auxx=matrixsq1*weight
      if(auxx.ne.auxx) then
         print *, "nan here"
         auxx=0.d0
      endif
      call recordevent(3, pjet, auxx)

      end subroutine

       
      subroutine top24coutbb(p, matrixsq, weight)
      implicit none
      double precision p(0:3, 6), matrixsq, pout(0:3, 6)
      double precision matrixsq1, weight, pjet(0:3, 6), auxx
      double complex sp(2, 2), aux(4)
      common /pass/ pjet
      include "para.inc"

      matrixsq=0.d0
      matrixsq1=0.d0

      call topdipole(5, 6, 4, 1, -1, p, pout, sp)

      call top23diposqamp(pout, aux)

      matrixsq1=-dble(sp(1, 1)*aux(1)+sp(2, 2)*aux(2)
     -     +sp(1, 2)*aux(3)+sp(2, 1)*aux(4))/2.d0

      matrixsq=matrixsq+matrixsq1
      auxx=matrixsq1*weight
      if(auxx.ne.auxx) then
         print *, "nan here"
         auxx=0.d0
      endif
      call recordevent(3, pjet, auxx)


      call topdipole(4, 6, 5, 1, -1, p, pout, sp)

      call top23diposqamp(pout, aux)

      matrixsq1=-dble(sp(1, 1)*aux(1)+sp(2, 2)*aux(2)
     -     +sp(1, 2)*aux(3)+sp(2, 1)*aux(4))/2.d0

      matrixsq=matrixsq+matrixsq1
      auxx=matrixsq1*weight
      if(auxx.ne.auxx) then
         print *, "nan here"
         auxx=0.d0
      endif
      call recordevent(3, pjet, auxx)

      end subroutine
       

      subroutine topdipole(i, j, k, fi, fj, pin, pout, sp)
      implicit none
      integer n, i, j, k, new(5), l, fi, fj, id
      double precision pin(0:3, 6), pout(0:3, 6), pij, pik, pjk, csh
      double precision dtt, dww, dtw, pd(3, 2), coe(2, 2), gm, ssh
      double precision gdot, cutfactor, gpt, pjet(0:3, 6), psum(0:3)
      double precision x, y, z, ppi(0:3), zn, mm, rr, ymax
      double precision pi12, pj12, pk12, cfac, ci, cj, ck, aux
      double complex sp(2, 2), pro(2), f1(6), f2(6)
      external gdot, gpt, gm
      common /pass/ pjet
      include "para.inc"

      do l=1, 5
      new(l)=l
      enddo
      do l=0, 3
      pout(l, 6)=0.d0
      enddo
      sp(1, 1)=dcmplx(0.d0, 0.d0)
      sp(1, 2)=dcmplx(0.d0, 0.d0)
      sp(2, 1)=dcmplx(0.d0, 0.d0)
      sp(2, 2)=dcmplx(0.d0, 0.d0)

      if((i.eq.j).or.(max(i,j).gt.6).or.(min(i,j).lt.4)) then

      print *, "wrong mom!"
      stop

      endif

      if(k.eq.1) then
            n=2
      elseif((k.gt.3).and.(k.lt.7).and.(k.ne.i).and.(k.ne.j)) then
            n=1
      else
            print *, "wrong mom!"
            stop
      endif      
 
      pij=gdot(pin(0, i), pin(0, j))
      pik=gdot(pin(0, i), pin(0, k))
      pjk=gdot(pin(0, j), pin(0, k))

      if(n.eq.1) then ! final-final

      y=pij/(pij+pik+pjk)
      z=pik/(pjk+pik)     !note that always put gluon on position i
      zn=1.d0-z
      new(4)=5-abs(fi+fj)
      new(5)=9-new(4)

      do l=0, 3
      pout(l, 1)=pin(l, 1)
      pout(l, 2)=pin(l, 2)
      pout(l, 3)=pin(l, 3)
      pout(l, new(4))=pin(l, i)+pin(l, j)-y/(1.d0-y)*pin(l, k)
      pout(l, new(5))=pin(l, k)/(1.d0-y)
      enddo

      if(y.gt.dipcut) then  !all restriction on phase space
      cutfactor=0.d0
      goto 100
      endif
     
      call determinecut(2, pout, pjet, cutfactor) !kinematic cuts
      if(cutfactor.eq.0.d0) goto 100

      if(abs(fi+fj).eq.1) then

      cfac=-ca/2.d0/cf

      aux=-2.d0*cf*(2.d0/(1.d0-zn*(1.d0-y))-(1.d0+zn))*cfac
      sp(1, 1)=dcmplx(aux, 0.d0)
      sp(2, 2)=dcmplx(aux, 0.d0)

      elseif(abs(fi).eq.0) then

      cfac=-ca/2.d0/ca

      call vxxxxx(pout(0, new(4)), 0.d0, 1, 1, f1)
      call vxxxxx(pout(0, new(4)), 0.d0, -1, 1, f2)
      
      aux=-4.d0*ca*(1.d0/(1.d0-z*(1.d0-y))+1.d0/(1.d0-zn*(1.d0-y))-2)
     -      *cfac
      sp(1, 1)=dcmplx(aux, 0.d0)
      sp(2, 2)=dcmplx(aux, 0.d0)
     
      do l=0, 3
      ppi(l)=z*pin(l, i)-zn*pin(l, j)
      enddo
      pro(1)=f1(1)*ppi(0)-f1(2)*ppi(1)-f1(3)*ppi(2)-f1(4)*ppi(3)
      pro(2)=f2(1)*ppi(0)-f2(2)*ppi(1)-f2(3)*ppi(2)-f2(4)*ppi(3)
      aux=-4.d0*ca/pij*cfac

      sp(1, 1)=sp(1, 1)+aux*dconjg(pro(1))*pro(1)
      sp(1, 2)=sp(1, 2)+aux*dconjg(pro(1))*pro(2)
      sp(2, 1)=sp(2, 1)+aux*dconjg(pro(2))*pro(1)
      sp(2, 2)=sp(2, 2)+aux*dconjg(pro(2))*pro(2)

      else

      cfac=-1.d0 ! cover all the collinear dipole for t->Wgqq

      call vxxxxx(pout(0, new(4)), 0.d0, 1, 1, f1)
      call vxxxxx(pout(0, new(4)), 0.d0, -1, 1, f2)
      
      aux=-2.d0*tr*cfac
      sp(1, 1)=dcmplx(aux, 0.d0)
      sp(2, 2)=dcmplx(aux, 0.d0)
     
      do l=0, 3
      ppi(l)=z*pin(l, i)-zn*pin(l, j)
      enddo
      pro(1)=f1(1)*ppi(0)-f1(2)*ppi(1)-f1(3)*ppi(2)-f1(4)*ppi(3)
      pro(2)=f2(1)*ppi(0)-f2(2)*ppi(1)-f2(3)*ppi(2)-f2(4)*ppi(3)
      aux=-2.d0/pij*cfac*(-2.d0*tr)

      sp(1, 1)=sp(1, 1)+aux*dconjg(pro(1))*pro(1)
      sp(1, 2)=sp(1, 2)+aux*dconjg(pro(1))*pro(2)
      sp(2, 1)=sp(2, 1)+aux*dconjg(pro(2))*pro(1)
      sp(2, 2)=sp(2, 2)+aux*dconjg(pro(2))*pro(2)

      endif

      elseif(n.eq.2) then ! final-initial

      new(4)=5-abs(fi+fj)
      new(5)=9-new(4)
      id=4+5+6-i-j

      do l=0, 3
      psum(l)=pin(l, 1)-pin(l, i)-pin(l, j)
      enddo

      mm=gm(pin(0, 1))**2
      rr=gm(psum(0))/gm(pin(0, 1))
      z=1.d0-2*pik/mm/(1.d0-rr**2)  !note that always put gluon on position i
      y=2*pij/mm/(1.d0-rr)**2
      ymax=(1+rr)**2*z*(1.d0-z)/(z+rr**2*(1.d0-z))
      
      if((y.gt.dipcut*ymax).and.(z.lt.(1.d0-dipcut))) then  !all restriction on phase space
      cutfactor=0.d0
      goto 100
      endif

      dtt=gdot(pin(0, 1), pin(0, 1))
      dww=gdot(psum(0), psum(0))
      dtw=gdot(pin(0, 1), psum(0))

      ssh=((dtt+dww)*dsqrt(dtw**2-dtt*dww)-dtw*(dtt-dww))/2.d0/dtt/dww
      csh=(-(dtt-dww)*dsqrt(dtw**2-dtt*dww)+dtw*(dtt+dww))/2.d0/dtt/dww

      coe(1, 1)=(csh-1.d0)/(dtw**2-dww*dtt)*(-dww)
      coe(2, 2)=(csh-1.d0)/(dtw**2-dww*dtt)*(-dtt)
      coe(1, 2)=(csh-1.d0)/(dtw**2-dww*dtt)*(dtw)+ssh
     -     /dsqrt(dtw**2-dtt*dww)
      coe(2, 1)=(csh-1.d0)/(dtw**2-dww*dtt)*(dtw)-ssh
     -     /dsqrt(dtw**2-dtt*dww)
      pd(1, 1)=gdot(pin(0, 2), pin(0, 1))
      pd(2, 1)=gdot(pin(0, 3), pin(0, 1))
      pd(3, 1)=gdot(pin(0, id), pin(0, 1))
      pd(1, 2)=gdot(pin(0, 2), psum(0))
      pd(2, 2)=gdot(pin(0, 3), psum(0))
      pd(3, 2)=gdot(pin(0, id), psum(0))
      
      do l=0, 3
      pout(l, 1)=pin(l, 1)
      pout(l, 2)=pin(l, 2)+(pd(1, 1)*coe(1, 1)+pd(1, 2)
     -  *coe(1, 2))*pin(l, 1)+(pd(1, 1)*coe(2, 1)+pd(1, 2)*coe(2, 2))
     -  *psum(l)
      pout(l, 3)=pin(l, 3)+(pd(2, 1)*coe(1, 1)+pd(2, 2)
     -  *coe(1, 2))*pin(l, 1)+(pd(2, 1)*coe(2, 1)+pd(2, 2)*coe(2, 2))
     -  *psum(l)
      pout(l, new(5))=pin(l, id)+(pd(3, 1)*coe(1, 1)+pd(3, 2)
     -  *coe(1, 2))*pin(l, 1)+(pd(3, 1)*coe(2, 1)+pd(3, 2)*coe(2, 2))
     -  *psum(l)
      enddo

      do l=0, 3
      pout(l, new(4))=pout(l, 1)-pout(l, 2)-pout(l, 3)-pout(l, new(5))
      enddo

      call determinecut(2, pout, pjet, cutfactor) !kinematic cuts
      if(cutfactor.eq.0.d0) goto 100
     
      if(abs(fi+fj).eq.1) then

      cfac=(ca-2.d0*cf)/2.d0/cf*(-cf)

      aux=(2.d0*(2.d0/(1.d0-z)-1.d0-z)-2*pij*mm/pik**2)*cfac
      sp(1, 1)=dcmplx(aux, 0.d0)
      sp(2, 2)=dcmplx(aux, 0.d0)

      elseif(abs(fi).eq.0) then

      cfac=-ca/2.d0/ca*(-4.d0*ca)

      pk12=gdot(pin(0, k), pout(0, new(4)))
      pi12=gdot(pin(0, i), pout(0, new(4)))
      pj12=gdot(pin(0, j), pout(0, new(4)))
      call vxxxxx(pout(0, new(4)), 0.d0, 1, 1, f1)
      call vxxxxx(pout(0, new(4)), 0.d0, -1, 1, f2)
      ck=-2.d0/mm/(1.d0-rr**2)/pk12*(pjk*pi12-pik*pj12)
      ci=2.d0*pjk/mm/(1.d0-rr**2)
      cj=-2.d0*pik/mm/(1.d0-rr**2)

      aux=(z/(1.d0-z)-2*mm*pij/4.d0/pik**2)*cfac
      sp(1, 1)=dcmplx(aux, 0.d0)
      sp(2, 2)=dcmplx(aux, 0.d0)
      
      do l=0, 3
      ppi(l)=ck*pin(l, k)+ci*pin(l, i)+cj*pin(l, j)
      enddo
      pro(1)=f1(1)*ppi(0)-f1(2)*ppi(1)-f1(3)*ppi(2)-f1(4)*ppi(3)
      pro(2)=f2(1)*ppi(0)-f2(2)*ppi(1)-f2(3)*ppi(2)-f2(4)*ppi(3)
      aux=(4.d0/mm**2*(dtw**2-rr**2*mm**2)/(1.d0-rr**2)**2/2.d0/pij)
     -    *cfac

      sp(1, 1)=sp(1, 1)+aux*dconjg(pro(1))*pro(1)
      sp(1, 2)=sp(1, 2)+aux*dconjg(pro(1))*pro(2)
      sp(2, 1)=sp(2, 1)+aux*dconjg(pro(2))*pro(1)
      sp(2, 2)=sp(2, 2)+aux*dconjg(pro(2))*pro(2)

      endif

      else
     
      print *, "wrong momentum transform"

      endif

      if((y.lt.0.d0).or.(y.gt.1.d0)) then
      print *, "warning x out of range in real dipole"
      endif

      if((z.lt.0.d0).or.(z.gt.1.d0)) then
      print *, "warning z out of range in real dipole"
      endif

      sp(1, 1)=sp(1, 1)*(4.d0*pi*alphas)/2.d0/pij
      sp(1, 2)=sp(1, 2)*(4.d0*pi*alphas)/2.d0/pij
      sp(2, 1)=sp(2, 1)*(4.d0*pi*alphas)/2.d0/pij
      sp(2, 2)=sp(2, 2)*(4.d0*pi*alphas)/2.d0/pij

100   return

      end subroutine
