      program main
      implicit none
      double precision xsec(0:3), error(0:3), timecost
      double complex A0
      integer i, j, ttm
      character*40 tee, time1, time2
      include "para.inc"


      call getarg(1, job)
      ttm=time8()
      call ctime(ttm, time1)
      call readvar

      write(*, *) "**************************************************"
      write(*, *) "*                                                *"
      write(*, *) "*                 NNTopDec 1.0                   *"
      write(*, *) "*          (J. Gao, C. S. Li, H. X. Zhu)         *"
      write(*, *) "*               v1.0, 20th, Jul, 2012            *"
      write(*, *) "*                                                *"
      write(*, *) "*                  reference:                    *"
      write(*, *) "*                arXiv:1210.2808                 *"
      write(*, *) "**************************************************"
      call flush()

      if((cor.eq.1).and.(order.eq.2)) then
      call ffini
      call setSM(MW0, MT, MB0, GF, rscale*MT, DIV, ewdR)
      else
      call initloop
      endif

      call totalxsec(xsec, error, 1)

      if((cor.eq.1).and.(order.eq.2)) then
      call ffexi
      endif

      ttm=time8()
      call ctime(ttm, time2)

      write(*, *) ">>"
      write(*, *) ">>"
      write(*, *) "Results summary:"
      write(*, '(A5,F8.3,A4,A4,F8.3,A4,A4,D12.5)') "mt=", mt, "GeV", "mw=", mw0, "GeV", "ds=", deltas
      write(*, '(A8,I2,A7,I2,A8,I5)') "order:", order, "cor:", cor, "iseed:", iseed
      write(*, '(A8,F7.5,A4,F9.3,A5)') "alfas=", alphas, "at", rscale*mt, "GeV"
      write(*, '(A15,D12.5,A4,D12.5)') "3-body decay:", xsec(1), "+-", error(1)
      write(*, '(A15,D12.5,A4,D12.5)') "4-body decay:", xsec(2), "+-", error(2)
      write(*, '(A15,D12.5,A4,D12.5)') "5-body decay:", xsec(3), "+-", error(3)
      write(*, *) "Combine results:"
      write(*, '(A14,D12.5,A4,D12.5,2X,5A)') "Decay width =", xsec(0), "+-", error(0), "GeV"
      write(*,'(A24)') "end of the calculation."
      write(*,'(A11,A30)') "time from:", time1 
      write(*,'(A11,A30)') "time   to:", time2 
      write(*,'(A7)') ">>>>>>"
      call flush()

      tee=trim(adjustl(adjustr(job)))//".sum"
      open(unit=356, file=tee, status='unknown')
      
      write(356, *) "**************************************************"
      write(356, *) "*                                                *"
      write(356, *) "*                 NNTopDec 1.0                   *"
      write(356, *) "*          (J. Gao, C. S. Li, H. X. Zhu)         *"
      write(356, *) "*               v1.0, 20th, Jul, 2012            *"
      write(356, *) "*                                                *"
      write(356, *) "*                  reference:                    *"
      write(356, *) "*                arXiv:1210.2808                 *"
      write(356, *) "**************************************************"
      write(356, *) ">>"
      write(356, *) ">>"
      write(356, *) "Results summary:"
      write(356, '(A5,F8.3,A4,A4,F8.3,A4,A4,D12.5)') "mt=", mt, "GeV", "mw=", mw0, "GeV", "ds=", deltas
      write(356, '(A8,I2,A7,I2,A8,I5)') "order:", order, "cor:", cor, "iseed:", iseed
      write(356, '(A8,F7.5,A4,F9.3,A5)') "alfas=", alphas, "at", rscale*mt, "GeV"
      write(356, '(A15,D12.5,A4,D12.5)') "3-body decay:", xsec(1), "+-", error(1)
      write(356, '(A15,D12.5,A4,D12.5)') "4-body decay:", xsec(2), "+-", error(2)
      write(356, '(A15,D12.5,A4,D12.5)') "5-body decay:", xsec(3), "+-", error(3)
      write(356, *) "Combine results:"
      write(356, '(A14,D12.5,A4,D12.5,2X,5A)') "Decay width =", xsec(0), "+-", error(0), "GeV"
      write(356,'(A24)') "end of the calculation."
      write(356,'(A11,A30)') "time from:", time1 
      write(356,'(A11,A30)') "time   to:", time2 
      write(356,'(A7)') ">>>>>>"

      close(356)       


      end program main



