      subroutine setSM(gm1, gm2, gm3, gc1, gc2, gc3, gc4)
      implicit none
      double precision gm1, gm2, gm3, gc1, gc2, gc3, gc4
      double precision Dres, STAZ, STWW
      external Dres, STAZ, STWW
#include "vars.h"

      MW=gm1
      MW2=MW**2
      MT=gm2
      MT2=MT**2
      MB=gm3
      MB2=MB**2

      CW=MW/MZ
      CW2=CW**2
      SW2=1.d0-CW2
      SW=dsqrt(SW2)

      GF=gc1
      Alfa = dsqrt(2.d0)/pi*GF*MW2*SW2
      
      Alfa2=Alfa**2

      call ModelDefaults 

      call setmudim(gc2)
      call setdelta(gc3)
      call setlambda(gc3+1.d0)
      epscoeff = 0
      Finite = 1
      ESOFTMAX = 1D-4*MT

      call CalcRenConst

      print *, "Contributions to delta_R:"
      gc4=-dZAA1
      print *, gc4, "+alfa"

      gc4=gc4-2.d0*dSW1/SW
      print *, gc4, "+rho"

      gc4=gc4+Dres(MW2)
      print *, gc4, "+res"

      gc4=gc4+(STWW(0.d0)-STWW(MW2))/MW2
      print *, gc4, "+WW"

      gc4=gc4+2.d0*CW/SW*STAZ(0.d0)/MZ2
      print *, gc4, "+AZ"

      end subroutine


      double precision function Dalf(Q2)
      implicit none
#include "vars.h"
      integer Gen3
      double precision Q2

      Dalf=0.d0

	LOOP(Gen3, 1,3,1)

        Dalf=Dalf+3.d0*(2.d0/3.d0)**2*(dlog(Q2/Mf2(3, Gen3))-5.d0/3.d0)

        Dalf=Dalf+3.d0*(1.d0/3.d0)**2*(dlog(Q2/Mf2(4, Gen3))-5.d0/3.d0)

        Dalf=Dalf+1.d0*(3.d0/3.d0)**2*(dlog(Q2/Mf2(2, Gen3))-5.d0/3.d0)

	ENDLOOP(Gen3)

      Dalf=Dalf*(Alfa/3.d0/pi)

      end function

      double precision function Drho(Q2)
      implicit none
#include "vars.h"
      integer Gen3
      double precision Q2

        Drho=3.d0*GF*MT2/8.d0/dsqrt(2.d0)/pi**2*(1.d0+0.d0*GF*MT2*(19.d0-2.d0*pi**2)
     &     /8.d0/dsqrt(2.d0)/pi**2)

      end function

      double precision function Dres(Q2)
      implicit none
#include "vars.h"
      integer Gen3
      double precision Q2

       Dres=(Alfa/4.d0/pi/SW2)*(6.d0+(7.d0-4.d0*SW2)*dlog(CW2)/2.d0/SW2)

      end function

      double precision function STAZ(psq)
      implicit none
#include "vars.h"
      integer Gen3
      double precision psq, fermion, boson, BK0
      external BK0

      fermion=0.d0
      boson=0.d0

	LOOP(Gen3, 1,3,1)
  
        fermion=fermion+(2.d0/3.d0)*((-(psq+2.d0*Mf2(3,Gen3))
     &     *Re(B0(psq,Mf2(3,Gen3),Mf2(3,Gen3)))
     &     +2.d0*Mf2(3,Gen3)*Re(B0(0.d0,Mf2(3,Gen3),Mf2(3,Gen3)))+psq/3.d0)
     &     *3.d0*(-2.d0/3.d0)*((1.d0/2.d0-2.d0*SW2*2.d0/3.d0)/SW/CW))
   
        fermion=fermion+(2.d0/3.d0)*((-(psq+2.d0*Mf2(2,Gen3))
     &      *Re(B0(psq,Mf2(2,Gen3),Mf2(2,Gen3)))
     &     +2.d0*Mf2(2,Gen3)*Re(B0(0.d0,Mf2(2,Gen3),Mf2(2,Gen3)))+psq/3.d0)
     &     *1.d0*(1.d0)*((-1.d0/2.d0+2.d0*SW2*1.d0)/SW/CW))
   
        fermion=fermion+(2.d0/3.d0)*((-(psq+2.d0*Mf2(4,Gen3))
     &      *Re(B0(psq,Mf2(4,Gen3),Mf2(4,Gen3)))
     &     +2.d0*Mf2(4,Gen3)*Re(B0(0.d0,Mf2(4,Gen3),Mf2(4,Gen3)))+psq/3.d0)
     &     *3.d0*(1.d0/3.d0)*((-1.d0/2.d0+2.d0*SW2*1.d0/3.d0)/SW/CW))

	ENDLOOP(Gen3)

        boson=boson-1.d0/3.d0/SW/CW*((psq*(0.5d0+9.d0*CW2)+MW2*(4.d0+12.d0*CW2))
     &    *Re(B0(psq,MW2,MW2))-(12.d0*CW2-2.d0)*MW2*Re(B0(0.d0,MW2,MW2))+psq/3.d0)
   
       STAZ=-(Alfa/4.d0/pi)*(fermion+boson)

      end function

      double precision function STWW(psq)
      implicit none
#include "vars.h"
      integer Gen3
      double precision psq, fermion, boson, BK0
      external BK0

      fermion=0.d0
      boson=0.d0

	LOOP(Gen3, 1,3,1)

        fermion=fermion+3.d0*(2.d0/3.d0)/2.d0/SW2*(-(psq-(Mf2(3, Gen3)+Mf2(4, Gen3))/2.d0)
     &    *Re(B0(psq,Mf2(3,Gen3),Mf2(4,Gen3)))+psq/3.d0+Mf2(3,Gen3)*
     &    Re(B0(0.d0,Mf2(3,Gen3),Mf2(3,Gen3)))+Mf2(4,Gen3)*Re(B0(0.d0,Mf2(4,Gen3),Mf2(4,Gen3)))
     &    +Bk0(Mf2(3,Gen3),Mf2(4,Gen3))/2.d0)
   
        fermion=fermion+1.d0*(2.d0/3.d0)/2.d0/SW2*(-(psq-(0.d0+Mf2(2, Gen3))/2.d0)
     &    *Re(B0(psq,0.d0,Mf2(2,Gen3)))+psq/3.d0
     &    +Mf2(2,Gen3)*Re(B0(0.d0,Mf2(2,Gen3),Mf2(2,Gen3)))
     &    +BK0(0.d0,Mf2(2,Gen3))/2.d0)

	ENDLOOP(Gen3)
   
        boson=boson+2.d0/3.d0*((2.d0*MW2+5.d0*psq)*Re(B0(psq,MW2,0.d0))-2.d0*MW2*
     &   Re(B0(0.d0,MW2,MW2))-BK0(MW2,0.d0)+psq/3.d0)

        boson=boson+1.d0/12.d0/SW2*(((16.d0*CW2+54.d0-10.d0/CW2)*MW2+
     &    (40.d0*CW2-1.d0)*psq)*Re(B0(psq,MW2,MZ2))-(2.d0+16.d0*CW2)*(
     &    MW2*Re(B0(0.d0,MW2,MW2))+MZ2*Re(B0(0.d0,MZ2,MZ2)))
     &    -(1.d0+8.d0*CW2)*BK0(MW2,MZ2)+2.d0*(4.d0*CW2-1.d0)*psq/3.d0)

        boson=boson+1.d0/12.d0/SW2*((2.d0*MH2-10.d0*MW2
     &    -psq)*Re(B0(psq,MW2,MH2))-2.d0*(
     &    MW2*Re(B0(0.d0,MW2,MW2))+MH2*Re(B0(0.d0,MH2,MH2)))
     &    -BK0(MW2,MH2)-2.d0*psq/3.d0)

       STWW=-(Alfa/4.d0/pi)*(fermion+boson)

      end function

      double precision function BK0(m02, m12)
      implicit none
      double precision m02, m12

      if(m02.eq.m12) then

      BK0=0.d0

      elseif(m02*m12.eq.0.d0) then

      BK0=(m12**2-m02**2)/(m12-m02)/2.d0

      else

      BK0=(m12**2-m02**2+2.d0*m02*m12*dlog(m02/m12))/(m12-m02)/2.d0

      endif

      end function

