      subroutine mcfmsqamp(p, results)
      implicit none
      double precision p(0:3, 6), results(2)
      double precision factor(2), averagefactor, colorfactor
      double precision q(6, 4), dot, pin(0:3, 6)
      double complex bornamp(2, 2), coe(2, 2), newbornamp(2, 2), newloopamp(2, 2)
      double complex spp, spm, smm, smp, virt_pp, virt_mm, virt_mp, virt_pm
      integer i, j
      external virt_pp, virt_mm, virt_pm, virt_mp
      include "para.inc"
      include "zprods_com.f"
      include 'epinv.f'
      include 'scale.f'
      include 'b0.f'

      averagefactor=1.d0/2.d0/nc
      colorfactor=cf*nc
      factor(1)=4.d0*(4.d0*pi*alphas)*(4.d0*dsqrt(2.d0)*GF*mw**2)*
     -        averagefactor*colorfactor
      factor(2)=factor(1)*alphas/4.d0/pi
      b0 = (nc*11d0-2d0*nf)/6d0
     
      do j=1, 5  
      do i=1, 3
      q(j, i)=dsign(1.d0, (j-1.5d0))*p(i, j)
      enddo 
      q(j, 4)=dsign(1.d0, (j-1.5d0))*p(0, j) 
      enddo 

      do i=1, 4
      q(6, i)=q(1, i)-q(5, i)*mt**2/2.d0/dot(q, 1, 5)
      enddo 

      call spinoru(6,q,za,zb)
 
      call tree(mt,5,4,2,3,6,bornamp)

      call project(q, mt, coe)

! Important notice that helas oxxxxx has discontinuty for zero 3 momentum
! the spin will be flippeed for massive particle near zero momentum
! thus the cp-transformation will bee different (top<=>anti-top)

      if(por.ne.0) then
      if((abs(p(1, 1))+abs(p(2, 1))+abs(p(3, 1))).eq.0.d0) then
      coe(2+(-por-1)/2, 1)=dcmplx(0.d0, 0.d0)      
      coe(2+(-por-1)/2, 2)=dcmplx(0.d0, 0.d0)
      else
      coe(2+(por-1)/2, 1)=dcmplx(0.d0, 0.d0)      
      coe(2+(por-1)/2, 2)=dcmplx(0.d0, 0.d0)
      endif
      endif

      newbornamp(1, 1)=coe(1, 1)*bornamp(1, 1)+coe(1, 2)*bornamp(2, 1)
      newbornamp(1, 2)=coe(1, 1)*bornamp(1, 2)+coe(1, 2)*bornamp(2, 2)
      newbornamp(2, 1)=coe(2, 1)*bornamp(1, 1)+coe(2, 2)*bornamp(2, 1)
      newbornamp(2, 2)=coe(2, 1)*bornamp(1, 2)+coe(2, 2)*bornamp(2, 2)

      epinv = div
      musq = rscale**2*mt**2
      spp=virt_pp(mt,5,4,2,3,1,q)
      spm=virt_pm(mt,5,4,2,3,1,q)
      smm=virt_mm(mt,5,4,2,3,1,q)
      smp=virt_mp(mt,5,4,2,3,1,q)

      newloopamp(1, 1)=coe(1, 1)*smm+coe(1, 2)*spm
      newloopamp(1, 2)=coe(1, 1)*smp+coe(1, 2)*spp
      newloopamp(2, 1)=coe(2, 1)*smm+coe(2, 2)*spm
      newloopamp(2, 2)=coe(2, 1)*smp+coe(2, 2)*spp

      results(1) = dble(newbornamp(1, 1)*dconjg(newbornamp(1,1))
     & +newbornamp(1, 2)*dconjg(newbornamp(1,2))
     & +newbornamp(2, 1)*dconjg(newbornamp(2,1))
     & +newbornamp(2, 2)*dconjg(newbornamp(2,2)))

      results(2) = 2.d0*dble(newloopamp(1, 1)*dconjg(newbornamp(1,1))
     & +newloopamp(1, 2)*dconjg(newbornamp(1,2))
     & +newloopamp(2, 1)*dconjg(newbornamp(2,1))
     & +newloopamp(2, 2)*dconjg(newbornamp(2,2)))

      results(1) = results(1)*factor(1)
      results(2) = results(2)*factor(2)

      end subroutine


      subroutine project(q, mt, coe)
      implicit none
      double precision q(6, 4), pt(0:3), pg(0:3), mt, dot, pb(0:3)
      double complex coe(2, 2), fp(6), fm(6), fgm(6), fgp(6)
      double complex g0(4, 4), g1(4, 4), g2(4, 4), g3(4, 4)
      integer i, j
      include "constants.f"
      include "zprods_com.f"
  
      g0=czip
      g1=czip
      g2=czip
      g3=czip
      coe=czip

      g0(1, 3)=cone
      g0(2, 4)=cone
      g0(3, 1)=cone
      g0(4, 2)=cone

      g1(1, 4)=cone
      g1(2, 3)=cone
      g1(3, 2)=-cone
      g1(4, 1)=-cone

      g2(1, 4)=-im
      g2(2, 3)=im
      g2(3, 2)=im
      g2(4, 1)=-im

      g3(1, 3)=cone
      g3(2, 4)=-cone
      g3(3, 1)=-cone
      g3(4, 2)=cone

      pt(0)=-q(1, 4)
      pt(1)=-q(1, 1)
      pt(2)=-q(1, 2)
      pt(3)=-q(1, 3)

      pg(0)=q(5, 4)
      pg(1)=q(5, 1)
      pg(2)=q(5, 2)
      pg(3)=q(5, 3)

      pb(0)=q(6, 4)
      pb(1)=q(6, 1)
      pb(2)=q(6, 2)
      pb(3)=q(6, 3)

      call oxxxxx(pt, mt,  1, -1, fp)
      call oxxxxx(pt, mt, -1, -1, fm)
      call sspin(pg,  1, fgm)
      call sspin(pg, -1, fgp)
      
      
      do i=1, 4 
      do j=1, 4
      coe(1, 1)=coe(1, 1)-fm(i)*(pt(0)*g0(i, j)-pt(1)*g1(i,j)
     -     -pt(2)*g2(i,j)-pt(3)*g3(i,j))*fgm(j)
      coe(1, 2)=coe(1, 2)-fm(i)*(pt(0)*g0(i, j)-pt(1)*g1(i,j)
     -     -pt(2)*g2(i,j)-pt(3)*g3(i,j))*fgp(j)
      coe(2, 1)=coe(2, 1)-fp(i)*(pt(0)*g0(i, j)-pt(1)*g1(i,j)
     -     -pt(2)*g2(i,j)-pt(3)*g3(i,j))*fgm(j)
      coe(2, 2)=coe(2, 2)-fp(i)*(pt(0)*g0(i, j)-pt(1)*g1(i,j)
     -     -pt(2)*g2(i,j)-pt(3)*g3(i,j))*fgp(j)
      enddo
      coe(1, 1)=coe(1, 1)+mt*fm(i)*fgm(i)
      coe(1, 2)=coe(1, 2)+mt*fm(i)*fgp(i)
      coe(2, 1)=coe(2, 1)+mt*fp(i)*fgm(i)
      coe(2, 2)=coe(2, 2)+mt*fp(i)*fgp(i)
      enddo

      coe(1, 1)=coe(1, 1)/za(6, 5)/2.d0/mt
      coe(2, 1)=coe(2, 1)/za(6, 5)/2.d0/mt
      coe(1, 2)=coe(1, 2)/zb(6, 5)/2.d0/mt
      coe(2, 2)=coe(2, 2)/zb(6, 5)/2.d0/mt

      end subroutine

      subroutine sspin(p, n, am)
      implicit none
      integer n
      double precision p(0:3), rt
      double complex am(6), f, c23
      include 'constants.f'
      
      am=czip
      if(n.eq.1) then
         if (p(0) .ge. 0.d0) then
            rt=dsqrt(p(0)+p(3))
            c23=dcmplx(p(1),p(2))
            f=cone
         else
            rt=dsqrt(-p(0)-p(3))
            c23=dcmplx(-p(1),-p(2))
            f=im
         endif
         am(3)=dcmplx(rt, 0.d0)*f
         am(4)=(1.d0/rt)*c23*f
      elseif(n.eq.-1) then
         if (p(0) .ge. 0.d0) then
            rt=dsqrt(p(0)+p(3))
            c23=dcmplx(-p(1),p(2))
            f=cone
         else
            rt=dsqrt(-p(0)-p(3))
            c23=dcmplx(p(1),-p(2))
            f=im
         endif
         am(2)=dcmplx(rt, 0.d0)*f
         am(1)=(1.d0/rt)*c23*f
      else
          print *, "wrong helicity!"
          stop
      endif

      end subroutine

      subroutine cptran(pin, p)
      implicit none
      double precision pin(0:3, 6), p(0:3, 6)
      integer i, j
      
      do j=1, 6
      do i=1, 3
      p(i, j)=-pin(i, j)
      enddo
      p(0, j)=pin(0, j)
      enddo

      end subroutine
