	program test
	implicit none
	include 'masses.f'
	include 'constants.f'
	include 'sprods_com.f'
	include 'zprods_com.f'
	include 'epinv.f'
	include 'scale.f'

	double complex bornamp(2,2)
	double complex spp,spm,smp,smm,
     &  virt_pp,virt_pm,virt_mp,virt_mm
	double precision p(6,4),q(6,4)
	double precision twotDg,dot
	double precision gs, gw, pref, ampsq,loopsq
	double precision datawgt
	integer k,j, i
! initialize the mass
	wmass = 80d0
	wwidth = wmass/24d0/pi/1d0
	twidth = 0d0
	mt = 173d0
	gs = dsqrt(4d0*pi*0.1d0)
	gw = dsqrt(4d0*pi*1d0/129d0)/dsqrt(0.231d0)
	pref = dsqrt(2d0)*gs*gw
	pref = pref**2*4d0/3d0
	
	open(unit=111,file="test.dat",status='unknown')
	do i=1, 100
	read(111,*) datawgt, datawgt,datawgt
	read(111,*) p(1,1),p(1,2),p(1,3),p(1,4)
	read(111,*) p(2,1),p(2,2),p(2,3),p(2,4)
	read(111,*) p(3,1),p(3,2),p(3,3),p(3,4)
	read(111,*) p(4,1),p(4,2),p(4,3),p(4,4)
	read(111,*) p(5,1),p(5,2),p(5,3),p(5,4)

	p(1,4) = -p(1,4)

!construct the auxiliary momenta
      twotDg=2d0*dot(p,5,1)
      do k=1,4
      do j=1,5
      q(j,k)=p(j,k)
      enddo
      q(6,k)=p(1,k)-p(5,k)*mt**2/twotDg
      enddo

c---fill matrices of spinor products  
	call spinoru(6,q,za,zb)
c      subroutine tree(mq,ig,is,ie,in,it,amp)
        call tree(mt,5,4,2,3,6,bornamp)

c calculate loop amplitude
c       first initialize divergence and scale
	epinv = 1d20
	musq = mt**2
c      double complex function virt_pp(mQ,ig,is,ie,in,ic,p)
	spp=virt_pp(mt,5,4,2,3,1,q)
        spm=virt_pm(mt,5,4,2,3,1,q)
        smm=virt_mm(mt,5,4,2,3,1,q)
        smp=virt_mp(mt,5,4,2,3,1,q)

	ampsq = bornamp(1,1)*dconjg(bornamp(1,1))
     &	+bornamp(1,2)*dconjg(bornamp(1,2))
     &	+bornamp(2,1)*dconjg(bornamp(2,1))
     &	+bornamp(2,2)*dconjg(bornamp(2,2))
	ampsq = ampsq*pref

c       loosq = M_virtual*dconjg(M_tree)
	loopsq = smm*dconjg(bornamp(1,1))
     &	+smp*dconjg(bornamp(1,2))
     &	+spm*dconjg(bornamp(2,1))
     &	+spp*dconjg(bornamp(2,2))
	loopsq = loopsq*pref*gs**2/(4d0*pi)**2

     	print *, ampsq,datawgt, ampsq/datawgt, loopsq

c the leading pole (1/ep^2) is -13/3/ep^2
	print *, "loop/born/(als/4pi)=", loopsq/ampsq/gs**2*(4d0*pi)**2
	
	print *, "HELLO WORLD"
	enddo
	close(111)
	end
