c======================================================================
c==kinematic functions including jet algorithm and event selection=====
      subroutine determinecut(nin, p, pout, cutfactor)
      integer nin, i, njet
      double precision cutfactor, p(0:3, 6), pjet(0:3, 3), pout(0:3, 6)
      double precision gm, ptot(0:3)
      include "para.inc"

      cutfactor=0.d0
      pout=0.d0
      pjet=0.d0
      ptot=0.d0

      do i=0, 3
      do j=1, nin
      ptot(i)=ptot(i)+p(i, 3+j)
      enddo
      enddo

      ttau=(gm(ptot)/mt)**2      

      if((gm(ptot).lt.(dsqrt(deltas)*mt)).and.(nin.ne.1)) then

      cutfactor=0.d0

      else

      if(jetalgo.le.1) then

      call lepkt(nin, p(0, 4), njet, pjet)

      else

      call jetfind(nin, p(0, 4), njet, pjet)

      call jettrigger(njet, pjet, cutfactor)

      endif

      do i=0, 3
      pout(i, 1)=p(i, 1)
      pout(i, 2)=p(i, 2)
      pout(i, 3)=p(i, 3)
      pout(i, 4)=pjet(i, 1)
      pout(i, 5)=pjet(i, 2)
      pout(i, 6)=pjet(i, 3)
      enddo

      call eventselect(pout, cutfactor)

      endif

      end subroutine

c=========================================================
      subroutine jetfind(nin, p, njet, pjet)
      implicit none
      integer nin, njet, nkey1, nkey2
      double precision p(0:3, 3), pjet(0:3, 3), pg(0:3)
      double precision paux(0:3, 3), dis(20), gpt
      double precision porder(0:3, 3)
      integer i, j, k
      external gpt
      include "para.inc"

      njet=0

      paux=p
      pjet=0.d0
      porder=0.d0

      do j=1, nin
      
      i=nin+1-j

      call distance(paux, i, jetalgo-1, dis)

      call mini(dis, i, nkey1, nkey2)

      if(nkey1.eq.nkey2) then
              njet=njet+1
              do k=0, 3
              pjet(k, njet)=paux(k, nkey1)
              paux(k, nkey1)=paux(k, i)
              enddo
      else
              call recombine(pg, paux(0, nkey1), paux(0, nkey2))
              do k=0, 3
              paux(k, nkey1)=pg(k)
              paux(k, nkey2)=paux(k, i)
              enddo
      endif

      enddo
      
      if(njet.ne.1) then

              if(gpt(pjet(0, 1)).gt.gpt(pjet(0, 2))) then
              do i=0, 3
              porder(i, 1)=pjet(i, 1)
              porder(i, 2)=pjet(i, 2)
              enddo
              else
              do i=0, 3
              porder(i, 1)=pjet(i, 2)
              porder(i, 2)=pjet(i, 1)
              enddo
              endif

              do i=0, 3
              pjet(i, 1)=porder(i, 1)
              pjet(i, 2)=porder(i, 2)
              enddo

              if(njet.eq.3) then

                      if(gpt(pjet(0, 3)).lt.gpt(porder(0, 2))) then
                      do i=0, 3
                      porder(i, 3)=pjet(i, 3)
                      enddo
                      elseif(gpt(pjet(0, 3)).gt.gpt(porder(0, 1))) then
                      do i=0, 3
                      porder(i, 3)=porder(i, 2)
                      porder(i, 2)=porder(i, 1)
                      porder(i, 1)=pjet(i, 3)
                      enddo
                      else
                      do i=0, 3
                      porder(i, 3)=porder(i, 2)
                      porder(i, 2)=pjet(i, 3)
                      enddo
                      endif

                      do i=0, 3
                      pjet(i, 1)=porder(i, 1)
                      pjet(i, 2)=porder(i, 2)
                      pjet(i, 3)=porder(i, 3)
                      enddo

              endif
      endif

      end subroutine
c=========================================================
      subroutine distance(p, i, algo, dis)
      implicit none
      integer i, j, k, nnc, algo
      double precision p(0:3, 3), dis(20)
      double precision gpt, gdRij
      external gpt, gdRij
      include "para.inc" 

      nnc=1

      if(i.gt.5) then
              print *, "jet>5!"
              stop
      endif
 
      if(algo.eq.1) then  !kt

      do j=1, i
      do k=j, i
      if(k.eq.j) then
      dis(nnc)=gpt(p(0, j))**2
      else
      dis(nnc)=min(gpt(p(0, j))**2, gpt(p(0, k))**2)
     -    *(gdRij(p(0, j), p(0, k))/Rcone)**2
      endif
      nnc=nnc+1
      enddo
      enddo

      elseif(algo.eq.2) then !anti-kt

      do j=1, i
      do k=j, i
      if(k.eq.j) then
      dis(nnc)=gpt(p(0, j))**(-2)
      else
      dis(nnc)=min(gpt(p(0, j))**(-2), gpt(p(0, k))**(-2))
     -    *(gdRij(p(0, j), p(0, k))/Rcone)**2
      endif
      nnc=nnc+1
      enddo
      enddo

      elseif(algo.eq.3) then  !CA

      do j=1, i
      do k=j, i
      if(k.eq.j) then
      dis(nnc)=1.d0
      else
      dis(nnc)=(gdRij(p(0, j), p(0, k))/Rcone)**2
      endif
      nnc=nnc+1
      enddo
      enddo

      else
              print *, "wrong jet algorithm!"
              stop
      endif

      end subroutine
c===========================================================
      subroutine mini(dis, i, nkey1, nkey2)
      implicit none
      double precision dis(20), maux
      integer i, nkey1, nkey2, j, k, nc

      nc=1
      maux=dis(1)
      nkey1=1
      nkey2=1

      do j=1, i
      do k=j, i

      if(dis(nc).lt.maux) then
              nkey1=j
              nkey2=k
              maux=dis(nc)
      endif

      nc=nc+1

      enddo
      enddo

      end subroutine
c==========================================================================                    
      subroutine recombine(po, p1, p2)
      implicit none
      double precision p1(0:3), p2(0:3), po(0:3), phi1, phi2
      double precision geta, gpt, gphi, et, et1, et2, ceta, cphi
      external get, gpt, gphi
      include "para.inc"

      if(recscheme.eq.2) then

      et1=abs(gpt(p1))
      et2=abs(gpt(p2))
      et=et1+et2

      ceta=(et1*geta(p1)+et2*geta(p2))/et
      phi1=gphi(p1)
      phi2=gphi(p2)
      if(abs(phi1-phi2).lt.pi) then
          cphi=(et1*phi1+et2*phi2)/et
      else
          if(phi2.gt.phi1) then
          cphi=(et1*(phi1+2.d0*pi)+et2*phi2)/et
          else
          cphi=(et2*(phi2+2.d0*pi)+et1*phi1)/et
          endif
      endif

      po(0)=et/dsin(2.d0*datan(abs(exp(-ceta))))
      po(1)=et*dcos(cphi)
      po(2)=et*dsin(cphi)
      po(3)=et/dtan(2.d0*datan(abs(exp(-ceta))))

      elseif(recscheme.eq.1) then

      po(0)=p1(0)+p2(0)
      po(1)=p1(1)+p2(1)
      po(2)=p1(2)+p2(2)
      po(3)=p1(3)+p2(3)

      else

        print *, "wrong recombination scheme!"
        stop

      endif

      end subroutine
c==========================================================================                    
      subroutine jettrigger(njet, pjet, cutfactor)
      implicit none 
      double precision pjet(0:3, 3), cutfactor
      double precision yy, pp, gy, gpt
      integer njet, i, j, nnew
      external gy, gpt
      include "para.inc"

      nnew=0
      cutfactor=1.d0

      do i=1, njet

      yy=abs(gy(pjet(0, i)))
      pp=gpt(pjet(0, i))

      if((abs(yy).lt.ycut).and.(pp.gt.ptcut)) then
      nnew=nnew+1
      do j=0, 3
      pjet(j, nnew)=pjet(j, i)
      enddo
      endif

      enddo
      
      do i=nnew+1, 3
      do j=0, 3
      pjet(j, i)=0.d0
      enddo
      enddo 


      end subroutine


c==========================================================================                    
c LEP JADE/kt algorithm based on definition of arXiv:0906.1833 
      subroutine lepkt(nin, p, njet, pjet)
      implicit none
      double precision p(0:3, 3), pjet(0:3, 3), paux(0:3, 3)
      double precision v1, v2, v3, v4, v5, v6,gvij,gvijk,ge,vm
      integer nin, njet, i 
      external gvij, gvijk, ge
      include "para.inc"

      pjet=0.d0
      paux=0.d0

      if(nin.eq.1) then

      njet=1
      do i=0, 3
      paux(i, 1)=p(i, 1)
      enddo

      elseif(nin.eq.2) then

      v1=gvij(p(0, 1), p(0, 2))
      if(v1.lt.Rcone) then
      njet=1
      do i=0, 3
      paux(i, 1)=p(i, 1)+p(i, 2)
      enddo
      else
      njet=2
      do i=0, 3
      paux(i, 1)=p(i, 1)
      paux(i, 2)=p(i, 2)
      enddo
      endif

      else

      v1=gvij(p(0, 1), p(0, 2))
      v2=gvij(p(0, 1), p(0, 3))
      v3=gvij(p(0, 2), p(0, 3))
      v4=gvijk(p(0, 1), p(0, 2), p(0, 3))
      v5=gvijk(p(0, 1), p(0, 3), p(0, 2))
      v6=gvijk(p(0, 2), p(0, 3), p(0, 1))
      vm=min(v1, v2, v3)
      if(vm.gt.Rcone) then
      njet=3
      do i=0, 3
      paux(i, 1)=p(i, 1)
      paux(i, 2)=p(i, 2)
      paux(i, 3)=p(i, 3)
      enddo
      elseif((vm.eq.v1).and.(v4.gt.Rcone)) then
      njet=2
      do i=0, 3
      paux(i, 1)=p(i, 1)+p(i, 2)
      paux(i, 2)=p(i, 3)
      enddo
      elseif((vm.eq.v2).and.(v5.gt.Rcone)) then
      njet=2
      do i=0, 3
      paux(i, 1)=p(i, 1)+p(i, 3)
      paux(i, 2)=p(i, 2)
      enddo
      elseif((vm.eq.v3).and.(v6.gt.Rcone)) then
      njet=2
      do i=0, 3
      paux(i, 1)=p(i, 2)+p(i, 3)
      paux(i, 2)=p(i, 1)
      enddo
      else
      njet=1 
      do i=0, 3
      paux(i, 1)=p(i, 1)+p(i, 2)+p(i, 3)
      enddo
      endif

      endif

      if(njet.eq.1) then

              do i=0, 3
              pjet(i, 1)=paux(i, 1)
              enddo
              
      else
              if(ge(paux(0, 1)).gt.ge(paux(0, 2))) then
              do i=0, 3
              pjet(i, 1)=paux(i, 1)
              pjet(i, 2)=paux(i, 2)
              enddo
              else
              do i=0, 3
              pjet(i, 1)=paux(i, 2)
              pjet(i, 2)=paux(i, 1)
              enddo
              endif

              if(njet.eq.3) then

                      if(ge(paux(0, 3)).lt.ge(pjet(0, 2))) then
                      do i=0, 3
                      pjet(i, 3)=paux(i, 3)
                      enddo
                      elseif(ge(paux(0, 3)).gt.ge(pjet(0, 1))) then
                      do i=0, 3
                      pjet(i, 3)=pjet(i, 2)
                      pjet(i, 2)=pjet(i, 1)
                      pjet(i, 1)=paux(i, 3)
                      enddo
                      else
                      do i=0, 3
                      pjet(i, 3)=pjet(i, 2)
                      pjet(i, 2)=paux(i, 3)
                      enddo
                      endif

              endif
      endif


      end subroutine

      
c==========================================================================                    
      subroutine eventselect(pin, cutfactor)
      implicit none
      double precision pin(0:3, 6), cutfactor
      
      cutfactor=1.d0


      end subroutine

c==========================================================================                    
      double precision function gvij(p1, p2)
      implicit none
      double precision p1(0:3), p2(0:3), gcosthij
      external gcosthij
      include "para.inc"

      if(jetalgo.eq.1) then
c JADE
      gvij=2.d0*p1(0)*p2(0)*(1.d0-gcosthij(p1, p2))/mt**2

      elseif(jetalgo.eq.0) then
c kt
      gvij=2.d0*min(p1(0)**2,p2(0)**2)*(1.d0-gcosthij(p1, p2))/mt**2

      else

      print *, "Wrong algorithm!"
      stop

      endif

      gvij=abs(gvij) 

      end function

c==========================================================================                    
      double precision function gvijk(p1, p2, p3)
      implicit none
      double precision p1(0:3), p2(0:3), p3(0:3), p4(0:3), gvij
      integer i
      external gvij

      do i=0, 3
      p4(i)=p1(i)+p2(i)
      enddo

      gvijk=gvij(p3, p4)       

      end function

      double precision function ge(p)
c************************************************************************
c     Returns energy of particle in lab frame
c************************************************************************
      IMPLICIT NONE
      double precision p(0:3)

      ge = p(0)

      end

      double precision function gm(p)
      implicit none
      double precision p(0:3)
      
      gm=sqrt(abs(p(0)**2-p(1)**2-p(2)**2-p(3)**2))


      end function

      double precision function gphi(p)
c************************************************************************
c     Returns azimuthal angle phi of a particle
c************************************************************************
      implicit none
      double precision p(0:3)
      double precision denom,temp
      double precision pi
      parameter ( pi=3.1415926535897932385 )

      denom = dsqrt(p(1)**2 + p(2)**2)
      temp = max(-0.99999999d0, p(1) / denom)
      temp = min( 0.99999999d0, temp)
      if (p(2).ge.0d0)then
         gphi =  dacos(temp)
      else
         gphi = -dacos(temp) + 2d0*pi
      endif

      end

      double precision function gpt(p)
c************************************************************************
c     Returns transverse momentum of particle
c************************************************************************
      IMPLICIT NONE
      double precision p(0:3)

      gpt = dsqrt(p(1)**2+p(2)**2)

      end


      DOUBLE PRECISION  FUNCTION gy(p)
c************************************************************************
c     Returns rapidity of particle in the lab frame
c************************************************************************
      IMPLICIT NONE
      double precision  p(0:3)

      gy=0.5d0*dlog((p(0)+p(3))/(p(0)-p(3)))

      end

      DOUBLE PRECISION  FUNCTION geta(p)
c************************************************************************
c     Returns pseudo-rapidity of particle in the lab frame
c************************************************************************
      IMPLICIT NONE
      double precision  p(0:3)
      double precision gcosth

      if (abs(gcosth(p)).lt.0.9999999999d0)then
         geta = -dlog(dtan(0.5d0*dacos(gcosth(p))))
      elseif (gcosth(p).ge.0.9999999999d0)then
         geta =  10d0
      else
         geta = -10d0
      endif

      end

      DOUBLE PRECISION  FUNCTION gcosth(p)
c************************************************************************
c     Returns the cosine of the angle between the particle and the +z axis
c************************************************************************
      IMPLICIT NONE
      double precision  p(0:3)
      double precision gpt, pm

      pm = dsqrt(p(3)**2+gpt(p)**2)
      if (abs(pm-p(3)).ge.abs(1d-10*p(3)))then
         gcosth = p(3)/pm
      else
         gcosth = 1d0
      endif

      end

      DOUBLE PRECISION  FUNCTION gcosthij(p1, p2)
c************************************************************************
c     Returns the cosine of the angle between the particles
c************************************************************************
      IMPLICIT NONE
      double precision  p1(0:3), p2(0:3)
      double precision gpt, pm1, pm2

      pm1 = dsqrt(p1(3)**2+gpt(p1)**2)
      pm2 = dsqrt(p2(3)**2+gpt(p2)**2)

      gcosthij=(p1(1)*p2(1)+p1(2)*p2(2)+p1(3)*p2(3))/pm1/pm2

      end
      double precision function gdot(p1,p2)
C****************************************************************************
C     4-Vector Dot product
C****************************************************************************
      implicit none
      double precision p1(0:3),p2(0:3)
      gdot=p1(0)*p2(0)-p1(1)*p2(1)-p1(2)*p2(2)-p1(3)*p2(3)
      end

      double precision function SumDot(P1,P2,dsign)
c************************************************************************
c     Invarient mass of 2 particles
c************************************************************************
      IMPLICIT NONE
      double precision p1(0:3),p2(0:3),dsign
      integer i
      double precision ptot(0:3)
      double precision gdot
      external gdot

      do i=0,3
         ptot(i)=p1(i)+dsign*p2(i)
      enddo
      SumDot = gdot(ptot,ptot)

      RETURN
      END

      double precision function gmij(P1,P2)
c************************************************************************
c     Invarient mass of 2 particles
c************************************************************************
      IMPLICIT NONE
      double precision p1(0:3),p2(0:3)
      double precision sumdot
      external sumdot

      gmij = dsqrt(Sumdot(p1,p2,1d0))

      RETURN
      END

      double precision function gmijk(P1,P2,P3)
c************************************************************************
c     Invarient mass of 3 particles
c************************************************************************
      IMPLICIT NONE
      double precision p1(0:3),p2(0:3),p3(0:3),p(0:3)
      double precision sumdot
      integer ii
      external sumdot

      do ii=0,3
      p(ii)=p2(ii)+p3(ii)
      enddo

      gmijk = dsqrt(Sumdot(p1,p,1d0))

      RETURN
      END

      double precision function gdelta_phi(p1,p2)
c************************************************************************
c     Returns separation in phi of two particles
c************************************************************************
      implicit none
      double precision p1(0:3),p2(0:3)
      double precision DENOM, TEMP

      DENOM = SQRT(P1(1)**2 + P1(2)**2) * SQRT(P2(1)**2 + P2(2)**2)
      TEMP = MAX(-0.99999999D0, (P1(1)*P2(1) + P1(2)*P2(2)) / DENOM)
      TEMP = MIN( 0.99999999D0, TEMP)
      gDELTA_PHI = ACOS(TEMP)

      END

      double precision function gdRij(P1,P2)
c************************************************************************
c     Distance in eta,phi between two particles.
c************************************************************************
      IMPLICIT NONE
      double precision p1(0:3),p2(0:3)
      double precision gy,gDELTA_PHI,R2
      external gy,gdelta_phi

      R2 = (gDELTA_PHI(P1,P2))**2+(gy(p1)-gy(p2))**2
      gdRij = dsqrt(R2)

      RETURN

      end
