      double precision function topint(x, weight)
      implicit none
      double precision weight, x(9), top22, top23, top24
      external top22, top23, top24
      include "para.inc"

      level: select case (nout)

      case(1)

      topint=top22(x, weight, 'lo')
      
      case(2)

      topint=top22(x, weight, 'nlo')
      
      case(3)

      topint=top22(x, weight, 'nnlo')
      
      case(4)

      topint=top23(x, weight, 'lo')
      
      case(5)

      topint=top23(x, weight, 'nlo')
      
      case(6)

      topint=top24(x, weight, 'lo')
      
      case default

      print *, "wrong level!"
      stop

      end select level

      end function
c====================================================

      double precision function top22(x, weight, zz)
      implicit none
      integer i, n
      double precision weight, cutfactor, aau(2)
      double precision x(9), pcms(0:3, 6), nin, pout(0:3, 6)
      double precision results, pwbo(0:3), pmid(0:3)
      double precision paux(0:3,2),paux1(0:3,2)
      double precision flux, jacob
      double precision sqamp
      double precision massmid, massdown, massup
      character(*) zz
      include "para.inc"

      pcms=0.d0 
      jacob=1.d0
      cutfactor=0.d0
      sqamp=0.d0
      results=0.d0

      if((cor.ne.0.d0).and.(order.eq.1)) then
      call generatewmass(x(4), mw0, widw0, mw, jacob)
      widw=mw/24.d0/pi
      if((mw.le.1.d-3).or.(mw.gt.0.999d0*(mt-mb))) then
      top22=0
      return
      endif
      endif

      flux=1.d0/2.d0/mt/2.d0/mw/widw

      pcms(0, 1)=mt

      do n=1,3
      pcms(n, 1)=0.d0 
      enddo

      if(por.ne.0) pcms(3, 1)=1.d-10 ! tiny boost in z direction to define helicity 

      call generatephase1to2(0.25d0, x(1), mt, mb, mw, paux, jacob)

      do n=0,3
      pcms(n, 4)=paux(n, 1) 
      pmid(n)=paux(n, 2)
      enddo

      if(his.eq.0) then
      call generatephase1to2(x(2), x(3), mw, 0.d0, 0.d0, paux, jacob)
      else
      call generatephase1to2ang(x(2), x(3), mw, 0.d0, 0.d0, paux, jacob)
      endif

      call ptransform(paux1, paux, pmid, 2)

      do n=0,3
      pcms(n, 2)=paux1(n, 1) 
      pcms(n, 3)=paux1(n, 2) 
      enddo


      call determinecut(1, pcms, pout, cutfactor)

      if(cutfactor.eq.1.d0) then
      if(zz.eq.'lo') then
      call top22treesqamp(pcms, sqamp)
      elseif(zz.eq.'nlo') then
      if((cor.ne.0.d0).and.(order.eq.2)) then
      call topewloopsqamp(pcms, aau)
      sqamp=aau(2)
      else
      call top22loopsqamp(pcms, sqamp, 1)
      endif
      elseif(zz.eq.'nnlo') then  
      call top22loopsqamp(pcms, sqamp, 2)
      endif
      else
      sqamp=0.d0
      endif

      results=flux*sqamp*jacob

      if(results.ne.results) then
         print *, "nan here"
         results=0.d0
      endif

      top22=results

      if(top22.ne.0.d0) then
      call recordevent(1, pout, top22*weight)
      endif

      end function     

c====================================================

      double precision function top23(x, weight, zz)
      implicit none
      integer i, n
      double precision weight, cutfactor, aau(2)
      double precision x(9), pcms(0:3, 6), pout(0:3, 6)
      double precision results, pwbo(0:3), pmid(0:3), pmidn(0:3)
      double precision paux(0:3,2),paux1(0:3,2)
      double precision flux, jacob
      double precision sqamp, mmc(2)
      double precision massmid, massdown, massup
      double complex aux(4)
      character(*) zz
      include "para.inc"

      pcms=0.d0 
      jacob=1.d0
      cutfactor=0.d0
      sqamp=0.d0
      results=0.d0

      flux=1.d0/2.d0/mt/2.d0/mw/widw

      pcms(0, 1)=mt

      do n=1,3
      pcms(n, 1)=0.d0 
      enddo

      if(por.ne.0) pcms(3, 1)=1.d-10 ! tiny boost in z direction to define helicity 

      massdown=mb
      massup=mt-mw
      if(massup.lt.massdown) then
      print *, "wrong mass cut!"
      stop
      endif
      call generateimass(x(1), massdown, massup, massmid, jacob)

      call generatephase1to2(0.25d0, x(2), mt, massmid, mw, paux, jacob)

      do n=0,3
      pmid(n)=paux(n, 1) 
      pmidn(n)=paux(n, 2)
      enddo

      call generatephase1to2(x(3), x(4), massmid, mb, 0.d0, paux, jacob)
      
      call ptransform(paux1, paux, pmid, 2)

      do n=0,3
      pcms(n, 4)=paux1(n, 1) 
      pcms(n, 5)=paux1(n, 2)
      enddo 

      if(his.eq.0) then
      call generatephase1to2(x(5), x(6), mw, 0.d0, 0.d0, paux, jacob)
      else
      call generatephase1to2ang(x(5), x(6), mw, 0.d0, 0.d0, paux, jacob)
      endif

      call ptransform(paux1, paux, pmidn, 2)

      do n=0,3
      pcms(n, 2)=paux1(n, 1) 
      pcms(n, 3)=paux1(n, 2) 
      enddo

      if((cor.ne.0.d0).and.(order.eq.2)) then
      call determinecut(1, pcms, pout, cutfactor)
      else
      call determinecut(2, pcms, pout, cutfactor)
      endif


      if(cutfactor.eq.1.d0) then
      if(zz.eq."lo") then
      if((cor.ne.0.d0).and.(order.eq.2)) then
      call topewrealsqamp(pcms, aau)
      sqamp=aau(1)
      else
      call top23treesqamp(pcms, sqamp)
      endif
      mmc=0.d0
      elseif(zz.eq."nlo") then
      call top23intdsqamp(pcms, sqamp)
      call mcfmsqamp(pcms, mmc)
      endif
      else
      sqamp=0.d0
      mmc=0.d0
      endif

      results=flux*(sqamp+mmc(2))*jacob

      if(results.ne.results) then
         print *, "nan here"
         results=0.d0
      endif

      top23=results

      if(top23.ne.0.d0) then
      call recordevent(2, pout, top23*weight)
      endif

      end function     

c====================================================

      double precision function top24(x, weight, zz)
      implicit none
      integer i, n
      double precision weight, cutfactor, aux
      double precision x(9), pcms(0:3, 6), pout(0:3, 6)
      double precision results, pwbo(0:3), pmid(0:3), pmidn(0:3)
      double precision paux(0:3,2),paux1(0:3,2), pmidnn(0:3)
      double precision flux, jacob, gdot, gao
      double precision sqamp, sqamp1, sqamp2
      double precision massmid, massdown, massup, massmidn
      double precision e4, e5, e6, p45, p46, p56, pcut, ecut, kkk
      character(*) zz
      external gdot
      include "para.inc"

      pcms=0.d0 
      jacob=1.d0
      cutfactor=0.d0
      sqamp1=0.d0
      sqamp2=0.d0
      results=0.d0

      flux=1.d0/2.d0/mt/2.d0/mw/widw

      pcms(0, 1)=mt

      do n=1,3
      pcms(n, 1)=0.d0 
      enddo

      if(por.ne.0) pcms(3, 1)=1.d-10 ! tiny boost in z direction to define helicity 

      massdown=mt*0.d0
      massup=mt-mw
      if(massup.lt.massdown) then
      print *, "wrong mass cut!"
      stop
      endif
      call generateimass(x(1), massdown, massup, massmid, jacob)

      call generatephase1to2(0.25d0, x(2), mt, massmid, mw, paux, jacob)

      do n=0,3
      pmid(n)=paux(n, 1) 
      pmidnn(n)=paux(n, 2)
      enddo
      
      if(his.eq.0) then
      call generatephase1to2(x(3), x(4), mw, 0.d0, 0.d0, paux, jacob)
      else
      call generatephase1to2ang(x(3), x(4), mw, 0.d0, 0.d0, paux, jacob)
      endif

      call ptransform(paux1, paux, pmidnn, 2)

      do n=0,3
      pcms(n, 2)=paux1(n, 1) 
      pcms(n, 3)=paux1(n, 2) 
      enddo

      massdown=0.d0
      massup=massmid
      if(massup.lt.massdown) then
      print *, "wrong mass cut!"
      stop
      endif
      call generateimass(x(5), massdown, massup, massmidn, jacob)

      call generatephase1to2(x(6), x(7), massmid, massmidn, 0.d0, paux, jacob)
      call ptransform(paux1, paux, pmid, 2)

      do n=0,3
      pmidn(n)=paux1(n, 1) 
      pcms(n, 4)=paux1(n, 2)
      enddo
      
      call generatephase1to2(x(8), x(9), massmidn, 0.d0, 0.d0, paux, jacob)
      
      call ptransform(paux1, paux, pmidn, 2)

      do n=0,3
      pcms(n, 5)=paux1(n, 1) 
      pcms(n, 6)=paux1(n, 2)
      enddo

      p45=gdot(pcms(0, 4), pcms(0, 5)) 
      p46=gdot(pcms(0, 4), pcms(0, 6)) 
      p56=gdot(pcms(0, 5), pcms(0, 6))
      e4=pcms(0, 4) 
      e5=pcms(0, 5) 
      e6=pcms(0, 6)
      ecut=des*mt 
      pcut=des*mt**2/5000.d0
      kkk=dsign(1.d0, e4-ecut)+dsign(1.d0, e5-ecut)+dsign(1.d0, e6-ecut)
     -  +dsign(1.d0, p45-pcut)+dsign(1.d0, p46-pcut)+dsign(1.d0, p56-pcut) 

      if(kkk.eq.6.d0) then
      call determinecut(3, pcms, pout, cutfactor)

      if(cutfactor.eq.1.d0) then
      call top24treesqamp(pcms, sqamp1)

      aux=flux*jacob*sqamp1*weight
      if(aux.ne.aux) then
         print *, "nan here"
         aux=0.d0
      endif

      if(sqamp1.ne.0.d0) then
      call recordevent(3, pout, aux)
      endif

      else
      sqamp1=0.d0
      endif
     
      call top24coutsqamp(pcms, sqamp2, flux*jacob*weight)
      results=flux*(sqamp1+sqamp2)*jacob
      endif

      if(results.ne.results) then
         print *, "nan here"
         results=0.d0
      endif

      top24=results

      end function     
  
c*****************************************************************************
c*****************************************************************************
                    
      subroutine beginevent
      implicit none
      double precision xsepre(0:3, 1000), errpre(0:3, 1000)
      double precision xsum(1000), x2sum(1000)
      integer i, j
      common /grid1/ xsepre, errpre
      common /grid2/ xsum, x2sum
      include "para.inc"


      if(ct(0).gt.1000) then
      print *, "kinematic bin out of range!"
      stop
      endif

      xsepre=0.d0
      errpre=0.d0
      
      end subroutine

c*****************************************************************************
c*****************************************************************************

      subroutine recordevent(njet, pin, weight)
      implicit none
      double precision weight, pin(0:3, 6)
      double precision error, mean, w1, w2
      integer it, tot, pretag, i, j, nn(10), njet
      integer preit, pretot, nt, ntag, mem(10, 12), ks(10), jj
      double precision xsepre(0:3, 1000), errpre(0:3, 1000)
      double precision xsum(1000), x2sum(1000), aux(10, 1000)
      integer maxeval, pseed, nstart, nincrease
      common /grid1/ xsepre, errpre
      common /grid2/ xsum, x2sum
      common /grid3/ preit, pretot, pretag
      common /iteration/ it, nt, ntag
      common /here/ aux, ks, mem
      common /gaovegas/ maxeval, pseed, nstart, nincrease
      include "para.inc"

      if(his.eq.0) return

      if((mod(it, (maxeval/nstart)/5).eq.0).and.(mod(ntag,nt).eq.0)
     -    .and.(ntag.ne.pretag)) then
      write(*,*) 20*it*5/(maxeval/nstart), "% complete..." 
      call flush()
      endif
         
      if(weight.ne.weight) then
         print *, "nan here in weight"
         weight=0.d0
         return
      endif

      call binmap(pin, nn)
      if(pretag.eq.0) then
      aux=0.d0
      mem=0
      ks=1
      xsum=0.d0
      x2sum=0.d0
      pretag=1
      endif

      if(it.ne.preit) then

      open(unit=EID(njet), file=FID(njet), status='unknown')
      preit=it

      do i=1, ct(0)

      if(xsum(i).ne.0.d0) then
      mean=xsum(i)
      error=(pretot*x2sum(i)-xsum(i)**2)/pretot
      error=dsqrt(abs(error))
      xsum(i)=0.d0
      x2sum(i)=0.d0
      if(xsepre(njet, i).ne.0.d0) then
      if(error.ne.0.d0) then
      w1=1.d0/(errpre(njet, i)**2)/(1.d0/(errpre(njet, i)**2)
     -      +1.d0/error**2)
      w2=1.d0-w1
      else
      w1=(preit-2.d0)/(preit-1.d0)
      w2=1.d0-w1
      endif
      xsepre(njet, i)=xsepre(njet, i)*w1+mean*w2
      errpre(njet, i)=dsqrt(w1**2*errpre(njet, i)**2+w2**2*error**2)
      else
      xsepre(njet, i)=mean
      errpre(njet, i)=error
      endif
      endif

      do j=1, nbin(0)
      if(i.eq.(ct(j)+1))  then
      write(EID(njet), '(A16,2X,I5,2D14.5)') label(j), nbin(j), bins(j, 1), bins(j ,2)
      endif
      enddo

      write(EID(njet), '(2D14.4,2X,2D14.5)') cod(i, 1), cod(i, 2), 
     -  norm(i)*xsepre(njet, i), norm(i)*errpre(njet, i)

      enddo
      pretot=nt
      close(EID(njet))

      endif


      do i=1, nbin(0)

      jj=nn(i)

      if(ntag.eq.pretag) then

      if(jj.ne.0) then

      aux(i, jj)=aux(i, jj)+weight
      mem(i, ks(i))=jj
      ks(i)=ks(i)+1

      endif

      else

      do j=1, 12

      if(mem(i, j).ne.0) then
      if(aux(i, mem(i, j)).ne.0.d0) then
      xsum(mem(i, j))=xsum(mem(i, j))+aux(i, mem(i, j))
      x2sum(mem(i, j))=x2sum(mem(i, j))+aux(i, mem(i, j))**2
      aux(i, mem(i, j))=0.d0
      endif
      mem(i, j)=0
      endif

      enddo

      ks(i)=1
      if(jj.ne.0) then
      aux(i, jj)=weight
      mem(i, ks(i))=jj
      ks(i)=ks(i)+1
      endif

      if(i.eq.nbin(0)) pretag=ntag

      endif

      enddo


      end subroutine

c*****************************************************************************
c*****************************************************************************

      subroutine endevent(njet)
      implicit none
      double precision error, mean, w1, w2
      integer preit,pretot,i,j,ks(10),pretag,njet
      integer it, tot,nt, ntag, mem(10, 12)
      double precision xsepre(0:3, 1000), errpre(0:3, 1000)
      double precision xsum(1000), x2sum(1000), aux(10, 1000)
      common /grid1/ xsepre, errpre
      common /grid2/ xsum, x2sum
      common /grid3/ preit, pretot, pretag
      common /iteration/ it, nt, ntag
      common /here/ aux, ks, mem
      include "para.inc"

      if(his.eq.0) return

      open(unit=EID(njet), file=FID(njet), status='unknown')

      do i=1, nbin(0)
      do j=1, 12

      if(mem(i, j).ne.0) then
      if(aux(i, mem(i, j)).ne.0.d0) then
      xsum(mem(i, j))=xsum(mem(i, j))+aux(i, mem(i, j))
      x2sum(mem(i, j))=x2sum(mem(i, j))+aux(i, mem(i, j))**2
      aux(i, mem(i, j))=0.d0
      endif
      mem(i, j)=0
      endif

      enddo
      enddo


      do i=1, ct(0)
      if(xsum(i).ne.0.d0) then
      mean=xsum(i)
      error=(nt*x2sum(i)-xsum(i)**2)/nt
      error=dsqrt(abs(error))
      xsum(i)=0.d0
      x2sum(i)=0.d0
      if(xsepre(njet, i).ne.0.d0) then
      if(error.ne.0.d0) then
      w1=1.d0/(errpre(njet, i)**2)/(1.d0/(errpre(njet, i)**2)
     -      +1.d0/error**2)
      w2=1.d0-w1
      else
      w1=(preit-2.d0)/(preit-1.d0)
      w2=1.d0-w1
      endif
      xsepre(njet, i)=xsepre(njet, i)*w1+mean*w2
      errpre(njet, i)=dsqrt(w1**2*errpre(njet, i)**2+w2**2*error**2)
      else
      xsepre(njet, i)=mean
      errpre(njet, i)=error
      endif
      endif

      do j=1, nbin(0)
      if(i.eq.(ct(j)+1))  then
      write(EID(njet), '(A16,2X,I5,2D14.5)') label(j), nbin(j), bins(j, 1), bins(j ,2)
      endif
      enddo

      write(EID(njet), '(2D14.4,2X,2D14.5)') cod(i, 1), cod(i, 2), 
     -  norm(i)*xsepre(njet, i), norm(i)*errpre(njet, i)
      enddo

      close(EID(njet))

      end subroutine

c*****************************************************************************
c*****************************************************************************
      subroutine binmap(pin, nn)
      implicit none
      double precision pin(0:3, 6), pw(0:3), yy(10)
      double precision bc, cth, gcosth, gm, gmij, gcosthij
      integer nn(10), i, pp
      external gcosth, gm ,gmij, gcosthij
      include "para.inc"

      yy=0.d0
      do i=0, 3
      pw(i)=pin(i, 2)+pin(i, 3)
      enddo
      bc=dsqrt(pw(1)**2+pw(2)**2+pw(3)**2)/pw(0)
      cth=gcosthij(pin(0, 2), pw)

      yy(1)=pin(0, 2)
      yy(2)=pin(0, 4)
      yy(3)=pin(0, 2)+pin(0, 4)+pin(0, 5)+pin(0, 6)
      yy(4)=gmij(pin(0, 2), pin(0, 4))
      yy(5)=gcosth(pin(0, 2))
      yy(6)=(cth-bc)/(1.d0-bc*cth)
      yy(7)=gcosthij(pin(0, 2), pin(0, 4))
c an example of user defined observable
      yy(8)=1.d0
     

      do i=1, nbin(0)

      pp=1+int(nbin(i)*(yy(i)-bins(i, 1))/(bins(i, 2)-bins(i, 1)))
      if((pp.ge.1).and.(pp.le.nbin(i))) then
      nn(i)=ct(i)+pp
      else
      nn(i)=0
      endif
      
      enddo
     
      end subroutine

c*****************************************************************************
c*****************************************************************************
      subroutine header(nn, xsec, err)
      implicit none
      integer nn
      double precision xsec(0:3), err(0:3)
      include "para.inc"

      write(nn, '(9I6, 2F8.3, D12.5)') nbin(0), ct(1:8), mt, mw0, deltas 
      write(nn, '(4D14.5)') xsec
      write(nn, '(4D14.5)') err

      end subroutine
