c*****************************************************************************
c**BEGINE of PART I: initializing of the inputs and calculation parameters   *
c*****************************************************************************


      subroutine readvar
      implicit none
      character*40 file1, file2, file3, file4
      
  
      file1='proinput.card'
      file2='varinput.card'
      file3='bininput.card'

      call proread(file1)
      call varread(file2)
      call readbin(file3)
      
 
      end subroutine


c*****************************************************************************
c*****************************************************************************
      subroutine proread(fil)
      implicit none
      double precision yy
      character*40 fil, xx, zz, file5
      integer i,j,n,maxeval,pseed,nstart,nincrease, ttm
      common /gaovegas/ maxeval, pseed, nstart, nincrease
      include "para.inc"

      i=1
      j=0
      open(unit=227, file=fil, status='unknown')

      do while(i.eq.1)

      read(227,*,end=400) xx, yy
      
      if(xx.eq.'rscale') then
              rscale=yy
              j=j+1
      elseif(xx.eq.'order') then
              order=yy
              j=j+1
      elseif(xx.eq.'por') then
              por=yy
              j=j+1
      elseif(xx.eq.'cor') then
              cor=yy
              j=j+1
      elseif(xx.eq.'his') then
              his=yy
              j=j+1
      elseif(xx.eq.'many') then
              many=yy
              j=j+1
      elseif(xx.eq.'div') then
              div=yy
              j=j+1
      elseif(xx.eq.'des') then
              des=yy
              j=j+1
      elseif(xx.eq.'deltas') then
              deltas=yy
              j=j+1
      elseif(xx.eq.'dipcut') then
              dipcut=yy
              j=j+1
      elseif(xx.eq.'Rcone') then
              Rcone=yy
              j=j+1
      elseif(xx.eq.'ptcut') then
              ptcut=yy
              j=j+1
      elseif(xx.eq.'ycut') then
              ycut=yy
              j=j+1
      elseif(xx.eq.'recscheme') then
              recscheme=yy
              j=j+1
      elseif(xx.eq.'jetalgo') then
              jetalgo=yy
              j=j+1
      elseif(xx.eq.'iseed') then
              iseed=yy
              j=j+1
      endif

      enddo

400   close(227)

      nstart=100000

      if(j.ne.16) then
              print *, "wrong in proinput.card!"
              stop
      endif

      if(many.gt.30) then
              print *, "limiration: try few many!"
              stop
      endif

      end subroutine
c*****************************************************************************
c*****************************************************************************

      subroutine varread(fil)
      implicit none
      double precision yy, nalphas, nni
      character*40 fil, xx, zz
      integer i,j,n
      common /brw/ nni
      external nalphas
      include "para.inc"

      i=1
      j=0
      open(unit=226, file=fil, status='unknown')


      do while(i.eq.1)

      read(226,*,end=400) xx, yy
      
      if(xx.eq.'mt') then
              j=j+1
              mt=yy
      elseif(xx.eq.'mw0') then
              j=j+1
              mw0=yy
      elseif(xx.eq.'mb0') then
              j=j+1
              mb0=yy
      elseif(xx.eq.'nf') then
              j=j+1
              nf=yy
      elseif(xx.eq.'GF') then
              j=j+1
              GF=yy
      elseif(xx.eq.'alphas') then
              j=j+1
              alphas=yy
      endif

      enddo

400   close(226)

      widw0=9.d0*GF*mw0**3/pi/dsqrt(2.d0)/6.d0

      if((cor.ne.0).and.(order.eq.1)) then
      mb=mb0
      mw=mw0
      nni=pi/2.d0/(widw0/mw0)
      elseif((cor.ne.0).and.(order.eq.2)) then
      mb=mb0
      mw=mw0
      widw=mw/24.d0/pi
      else
      mb=0.d0
      mw=mw0
      widw=mw/24.d0/pi
      endif

      alphas=nalphas(rscale*mt, alphas, 2) 

      if(j.ne.6) then
              print *, "wrong in kininput.card!"
              stop
      endif

      end subroutine

c*****************************************************************************
c*****************************************************************************

      subroutine readbin(fil)
      implicit none
      integer i, j
      double precision xx(3)
      character*40 zz, fil
      include "para.inc"

      i=0
      nbin=0
      ct=0
      bins=0.d0
      label(1)="E(e)" 
      label(2)="E(j1)" 
      label(3)="SE(ej)" 
      label(4)="M(ej1)" 
      label(5)="Cth(e)" 
      label(6)="Cth(*)" 
      label(7)="Cth(ej1)" 
      label(8)="xxxx" 
 
      open(unit=222, file=fil, status='unknown')

      do while(0.lt.1)

      read(222, *, end=300) zz, xx
      i=i+1

      if(zz.eq.'E(e)') then
              j=1
      elseif(zz.eq.'E(j1)') then
              j=2
      elseif(zz.eq.'SE(ej)') then
              j=3
      elseif(zz.eq.'M(ej1)') then
              j=4
      elseif(zz.eq.'Cth(e)') then
              j=5
      elseif(zz.eq.'Cth(*)') then
              j=6
      elseif(zz.eq.'Cth(ej1)') then
              j=7
      elseif(zz.eq.'xxxx') then
              j=8
      else
              print *, "no bin found!"
              stop
      endif

      nbin(j)=xx(3)
      bins(j, 1)=xx(1)
      bins(j, 2)=xx(2)

      enddo

300   if(i.ne.8) then
      print *, "wrong bin input!"
      stop
      endif

      nbin(0)=i
      ct(1)=0
      do j=2, 8
      ct(j)=nbin(j-1)+ct(j-1)
      enddo
      ct(0)=ct(8)+nbin(8)

      cod=0.d0
      do i=1, nbin(0)
      do j=1, nbin(i)
      cod(ct(i)+j, 1)=bins(i, 1)+(j-1)*(bins(i, 2)-bins(i, 1))/nbin(i)
      cod(ct(i)+j, 2)=bins(i, 1)+(j)*(bins(i, 2)-bins(i, 1))/nbin(i)
      norm(ct(i)+j)=nbin(i)/(bins(i, 2)-bins(i, 1))
      enddo
      enddo
     
      close(222)
 
      end subroutine

c*****************************************************************************
c*****************************************************************************

      subroutine totalxsec(totsec,error,it)
      double precision totsec(0:3),error(0:3),nnorm
      double precision xsepre(0:3, 1000), errpre(0:3, 1000)
      integer i, j, maxeval, pseed, nstar, nincrease
      character*10 aux
      external cuba
      external factintegrand
      common /grid1/ xsepre, errpre
      common /gaovegas/ maxeval, pseed, nstart, nincrease
      include "para.inc"
 
      EID(1)=325
      EID(2)=326
      EID(3)=327
      EID(0)=328
      write(aux, '(i10)') order
      FID(1)=trim(adjustl(adjustr(job)))//"_sam1_ode"//
     -       trim(adjustl(adjustr(aux)))//".dat"
      FID(2)=trim(adjustl(adjustr(job)))//"_sam2_ode"//
     -       trim(adjustl(adjustr(aux)))//".dat"
      FID(3)=trim(adjustl(adjustr(job)))//"_sam3_ode"//
     -       trim(adjustl(adjustr(aux)))//".dat"
      FID(0)=trim(adjustl(adjustr(job)))//"_sam0_ode"//
     -       trim(adjustl(adjustr(aux)))//".dat"
      totsec=0.d0
      error=0.d0

      call beginevent 

      if(order.eq.1) then

      if(iseed.eq.0) then
      pseed=int(time8())
      else
      pseed=iseed
      endif

      maxeval=60000000*many
      nout=1
      if(his.eq.1) then
      write(*,*) "Calculate separate contribution I:"
      write(*,*) "Random number seed=", pseed
      write(*,*) "Total number of sampling points=", maxeval
      write(*,*) "........"
      endif
      call cuba(factintegrand,totsec(1),error(1),9,1,-1999)
      call endevent(1)

      elseif(order.eq.2) then

      if(iseed.eq.0) then
      pseed=int(time8())
      else
      pseed=iseed
      endif

      maxeval=40000000*many
      if((cor.eq.1).and.(order.eq.2)) maxeval=400000*many
      nout=2
      if(his.eq.1) then
      write(*,*) "Calculate separate contribution I:"
      write(*,*) "Random number seed=", pseed
      write(*,*) "Total number of sampling points=", maxeval
      write(*,*) "........"
      endif
      call cuba(factintegrand,totsec(1),error(1),9,1,-1999)
      call endevent(1)

      if(iseed.eq.0) then
      pseed=int(time8())
      else
      pseed=iseed
      endif

      maxeval=40000000*many
      if((cor.eq.1).and.(order.eq.2)) maxeval=400000*many
      nout=4
      if(his.eq.1) then
      write(*,*) "Calculate separate contribution II:"
      write(*,*) "Random number seed=", pseed
      write(*,*) "Total number of sampling points=", maxeval
      write(*,*) "........"
      endif
      call cuba(factintegrand,totsec(2),error(2),9,1,-1999)
      call endevent(2)

      elseif(order.eq.3) then

      if(iseed.eq.0) then
      pseed=int(time8())
      else
      pseed=iseed
      endif

      maxeval=10000000*many
      nout=3
      if(his.eq.1) then
      write(*,*) "Calculate separate contribution I:"
      write(*,*) "Random number seed=", pseed
      write(*,*) "Total number of sampling points=", maxeval
      write(*,*) "........"
      endif
      call cuba(factintegrand,totsec(1),error(1),9,1,-1999)
      call endevent(1)

      if(iseed.eq.0) then
      pseed=int(time8())
      else
      pseed=iseed
      endif

      maxeval=2000000*many
      nout=5
      if(his.eq.1) then
      write(*,*) "Calculate separate contribution II:"
      write(*,*) "Random number seed=", pseed
      write(*,*) "Total number of sampling points=", maxeval
      write(*,*) "........"
      endif
      call cuba(factintegrand,totsec(2),error(2),9,1,-1999)
      call endevent(2)
       
      if(iseed.eq.0) then
      pseed=int(time8())
      else
      pseed=iseed
      endif

      maxeval=20000000*many
      nout=6
      if(his.eq.1) then
      write(*,*) "Calculate separate contribution III:"
      write(*,*) "Random number seed=", pseed
      write(*,*) "Total number of sampling points=", maxeval
      write(*,*) "........"
      endif
      call cuba(factintegrand,totsec(3),error(3),9,1,-1999)
      call endevent(3)

      else
 
      print *, "wrong order!"
      stop

      endif

      totsec(0)=totsec(1)+totsec(2)+totsec(3)
      error(0)=dsqrt(error(1)**2+error(2)**2+error(3)**2)

      if(his.ne.0) then

      open(unit=EID(0), file=FID(0), status='unknown')
      call header(EID(0), totsec, error)

      do i=1, ct(0)

      xsepre(0, i)=(xsepre(1, i)+xsepre(2, i)+xsepre(3, i))
      errpre(0, i)=dsqrt(errpre(1, i)**2+errpre(2, i)**2+errpre(3, i)**2)

      do j=1, nbin(0)
      if(i.eq.(ct(j)+1))  then
      write(EID(0), '(A16,2X,I5,2D14.5)') label(j), nbin(j), bins(j, 1), bins(j ,2)
      endif
      enddo

      write(EID(0), '(2D14.4,2X,2D14.5)') cod(i, 1), cod(i, 2), 
     -  norm(i)*xsepre(0, i), norm(i)*errpre(0, i)

      enddo

      close(EID(0))

      endif

      end subroutine

*********************************************************************

      integer function factintegrand(nd,xx,nc,results,userdata,wgt,it)
      implicit none
      integer userdata, maxeval, pseed, nstart, nincrease
      integer  nc, nd, i, j, it, nt, itnum, tot, ntag
      double precision  xx(nd), wgt
      double precision  results(nc), topint
      common /gaovegas/ maxeval, pseed, nstart, nincrease
      common /iteration/ itnum, tot, ntag
      external realint

      itnum=it
      tot=nstart+(itnum-1)*nincrease
      ntag=ntag+1
      factintegrand=1
      results(1)=topint(xx, wgt)

      if(((results(1).lt.0.d0).and.(results(1).gt.0.d0))
     -         .or.results(1)>1.d300) then
         print *, "nan here"
         stop
      endif

      end function
C***********************************************************************
C*********************************************************************

      subroutine cuba(integrand, result, error, nd, nc, key)
      implicit none
      integer  nd, nc, userdata, gridno, neval, fail
      integer  nbatch, statefilelen, key
      integer itnum, tot, ntag
      double precision   result(nc)
      double precision   error(nc)
      double precision  prob(nc)
      character*40 statefile
      integer  mineval
      integer  maxeval
      integer  flags
      integer  nstart
      integer  nincrease
      integer pseed
      integer preit, pretot, pretag
      double precision relac, absac
      common /gaovegas/ maxeval, pseed, nstart, nincrease
      common /iteration/ itnum, tot, ntag
      common /grid3/ preit, pretot, pretag
      external  vegas
      external  integrand

      relac=1.d-23
      absac=1.d-23
      mineval=0
      nincrease=0
      flags=1
      nbatch=1000
      gridno=key
      preit=1
      pretot=nstart
      pretag=0
      ntag=0

      call  Vegas(nd, nc, integrand, userdata,
     -    relac, absac, flags, pseed,
     -    mineval, maxeval, nstart, nincrease, 
     -    nbatch, gridno, statefile, neval, fail,
     -    result, error, prob)

      end subroutine cuba
C***********************************************************************
