c 1/2pi*dmkk**2/dx
      subroutine generateimass(x, mdown, mup, mass, jacob) 
      implicit none
      double precision x, jacob, mass, mdown, mup
      include "para.inc"

      if(mdown.gt.mup) then
             print *, "warning: wrong mass limit!"
             jacob=0.d0
             mass=mup
      else
      mass=mdown+x*(mup-mdown)
      jacob=jacob*(mup-mdown)*2.d0*mass/2.d0/pi 

      endif 

      end subroutine

      subroutine generatewmass(x, mc, ga, mass, jacob)
      implicit none
      double precision x, jacob, mass, mc, ga, nni
      common /brw/ nni
      include "para.inc"

      mass=mc+100.d0*(x-0.5d0)*ga
      jacob=100.d0*ga*jacob
      jacob=jacob*2.d0*mass/((mass**2-mc**2)**2+ga**2*mass**4/mc**2)

      jacob=jacob/(2.d0/mc**2*nni)*mass**2/mc**2

      end subroutine


      subroutine generatephase1to2(x, y, m1, m2, m3, p, jacob)
      implicit none
      double precision x, y, jacob, p(0:3,2), pout, m1, m2, m3
      double precision costheta, phi, sintheta, threemomentum
      external threemomentum
      include "para.inc"

      pout=threemomentum(m1, m2, m3)
      phi=2.d0*pi*x
      jacob=2.d0*pi*jacob 
      costheta=-1.d0+2.d0*y
      sintheta=dsqrt(1.d0-costheta**2)
      jacob=2.d0*jacob
c phase space factor
      jacob=pout/16.d0/pi**2/m1*jacob

      p(0,1)=dsqrt(m2**2+pout**2)
      p(1,1)=pout*sintheta*dcos(phi)
      p(2,1)=pout*sintheta*dsin(phi)
      p(3,1)=pout*costheta

      p(0,2)=dsqrt(m3**2+pout**2)
      p(1,2)=-pout*sintheta*dcos(phi)
      p(2,2)=-pout*sintheta*dsin(phi)
      p(3,2)=-pout*costheta


      end subroutine


      subroutine generatephase1to2ang(x, y, m1, m2, m3, p, jacob)
      implicit none
      double precision x, y, jacob, p(0:3,2), pout, m1, m2, m3
      double precision costheta, phi, sintheta, threemomentum, xx, yy
      external threemomentum
      include "para.inc"

      xx=x
      yy=rand(0)

      pout=threemomentum(m1, m2, m3)
      phi=2.d0*pi*xx
      jacob=2.d0*pi*jacob 
      costheta=-1.d0+2.d0*yy
      sintheta=dsqrt(1.d0-costheta**2)
      jacob=2.d0*jacob
c phase space factor
      jacob=pout/16.d0/pi**2/m1*jacob

      p(0,1)=dsqrt(m2**2+pout**2)
      p(1,1)=pout*sintheta*dcos(phi)
      p(2,1)=pout*sintheta*dsin(phi)
      p(3,1)=pout*costheta

      p(0,2)=dsqrt(m3**2+pout**2)
      p(1,2)=-pout*sintheta*dcos(phi)
      p(2,2)=-pout*sintheta*dsin(phi)
      p(3,2)=-pout*costheta


      end subroutine
!=====================================================================
!=====================================================================

      double precision function threemomentum(m1, m2, m3)
      implicit none
      double precision m1, m2, m3, psq

      if (m1.lt.(m2+m3)) then
              print *, "warning: wrong 3 momentum!"
              threemomentum=0.d0
              return
      endif

      psq=abs((m1**2+m2**2-m3**2)**2/4.d0/m1**2-m2**2)

      threemomentum=dsqrt(psq)

      end function

      subroutine pboost(pout,pin,beta,n)
      implicit none
      integer n,i
      double precision pin(0:3,n),pout(0:3,n),beta,gama

      if((beta.gt.1.d0).or.(beta.lt.-1.d0)) then
c              print *, "wrong beta!", beta
              beta=0.99999d0*beta/abs(beta)
      endif

      gama=1.d0/sqrt(1-beta*beta)
      
      do i=1,n
      pout(0,i)=gama*(pin(0,i)+beta*pin(3,i))
      pout(1,i)=pin(1,i)
      pout(2,i)=pin(2,i)
      pout(3,i)=gama*(pin(3,i)+beta*pin(0,i))
      enddo

      end subroutine
      
      subroutine protation(pout,pin,costheta,cosphi,sinphi,n)
      implicit none
      integer n,i
      double precision pin(0:3,n),pout(0:3,n),costheta,sintheta
      double precision cosphi,sinphi

      if((abs(costheta).gt.1.0001d0).or.(abs(cosphi).gt.1.0001d0)
     -   .or.(abs(sinphi).gt.1.0001d0)) then
              print *, "warning: wrong rotation!"
              print *, costheta, cosphi, sinphi
      endif

      sintheta=dsqrt(1.d0-costheta**2)

      do i=1,n
      pout(0,i)=pin(0,i)
      pout(1,i)=cosphi*pin(1,i)-sinphi*(costheta*pin(2,i)+sintheta*pin(3,i))
      pout(2,i)=sinphi*pin(1,i)+cosphi*(costheta*pin(2,i)+sintheta*pin(3,i))
      pout(3,i)=-sintheta*pin(2,i)+costheta*pin(3,i)
      enddo

      end subroutine


      subroutine ptransform(pout,pin,pmother,n)
      implicit none
      integer n,i
      double precision pin(0:3,n),pout(0:3,n),beta,costheta
      double precision paux(0:3,n),pmother(0:3),p
      double precision sintheta,sinphi,cosphi

      p=dsqrt(pmother(1)**2+pmother(2)**2+pmother(3)**2)
      beta=p/pmother(0)
      costheta=pmother(3)/p
      sintheta=dsqrt(1.d0-costheta**2)
      if(abs(sintheta).lt.1.d-10) then
              cosphi=1.d0
              sinphi=0.d0
      else
      cosphi=pmother(2)/p/sintheta
      sinphi=-pmother(1)/p/sintheta
      endif


      call pboost(paux, pin, beta, n)
      call protation(pout, paux, costheta, cosphi, sinphi, n)

      end subroutine

